// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/aiplatform/v1/migration_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2faiplatform_2fv1_2fmigration_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2faiplatform_2fv1_2fmigration_5fservice_2eproto__INCLUDED

#include "google/cloud/aiplatform/v1/migration_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace aiplatform {
namespace v1 {

// A service that migrates resources from automl.googleapis.com,
// datalabeling.googleapis.com and ml.googleapis.com to Vertex AI.
class MigrationService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.aiplatform.v1.MigrationService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Searches all of the resources in automl.googleapis.com,
    // datalabeling.googleapis.com and ml.googleapis.com that can be migrated to
    // Vertex AI's given location.
    virtual ::grpc::Status SearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>> AsyncSearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>>(AsyncSearchMigratableResourcesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>> PrepareAsyncSearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>>(PrepareAsyncSearchMigratableResourcesRaw(context, request, cq));
    }
    // Batch migrates resources from ml.googleapis.com, automl.googleapis.com,
    // and datalabeling.googleapis.com to Vertex AI.
    virtual ::grpc::Status BatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncBatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncBatchMigrateResourcesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncBatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncBatchMigrateResourcesRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Searches all of the resources in automl.googleapis.com,
      // datalabeling.googleapis.com and ml.googleapis.com that can be migrated to
      // Vertex AI's given location.
      virtual void SearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* request, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* request, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Batch migrates resources from ml.googleapis.com, automl.googleapis.com,
      // and datalabeling.googleapis.com to Vertex AI.
      virtual void BatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void BatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>* AsyncSearchMigratableResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>* PrepareAsyncSearchMigratableResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncBatchMigrateResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncBatchMigrateResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status SearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>> AsyncSearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>>(AsyncSearchMigratableResourcesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>> PrepareAsyncSearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>>(PrepareAsyncSearchMigratableResourcesRaw(context, request, cq));
    }
    ::grpc::Status BatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncBatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncBatchMigrateResourcesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncBatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncBatchMigrateResourcesRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void SearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* request, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* response, std::function<void(::grpc::Status)>) override;
      void SearchMigratableResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* request, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void BatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void BatchMigrateResources(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>* AsyncSearchMigratableResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>* PrepareAsyncSearchMigratableResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncBatchMigrateResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncBatchMigrateResourcesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_SearchMigratableResources_;
    const ::grpc::internal::RpcMethod rpcmethod_BatchMigrateResources_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Searches all of the resources in automl.googleapis.com,
    // datalabeling.googleapis.com and ml.googleapis.com that can be migrated to
    // Vertex AI's given location.
    virtual ::grpc::Status SearchMigratableResources(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* request, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* response);
    // Batch migrates resources from ml.googleapis.com, automl.googleapis.com,
    // and datalabeling.googleapis.com to Vertex AI.
    virtual ::grpc::Status BatchMigrateResources(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_SearchMigratableResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SearchMigratableResources() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_SearchMigratableResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchMigratableResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* /*request*/, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchMigratableResources(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_BatchMigrateResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_BatchMigrateResources() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_BatchMigrateResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchMigrateResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchMigrateResources(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_SearchMigratableResources<WithAsyncMethod_BatchMigrateResources<Service > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_SearchMigratableResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SearchMigratableResources() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* request, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* response) { return this->SearchMigratableResources(context, request, response); }));}
    void SetMessageAllocatorFor_SearchMigratableResources(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SearchMigratableResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchMigratableResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* /*request*/, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchMigratableResources(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* /*request*/, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_BatchMigrateResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_BatchMigrateResources() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* request, ::google::longrunning::Operation* response) { return this->BatchMigrateResources(context, request, response); }));}
    void SetMessageAllocatorFor_BatchMigrateResources(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_BatchMigrateResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchMigrateResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchMigrateResources(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_SearchMigratableResources<WithCallbackMethod_BatchMigrateResources<Service > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_SearchMigratableResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SearchMigratableResources() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_SearchMigratableResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchMigratableResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* /*request*/, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_BatchMigrateResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_BatchMigrateResources() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_BatchMigrateResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchMigrateResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_SearchMigratableResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SearchMigratableResources() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_SearchMigratableResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchMigratableResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* /*request*/, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSearchMigratableResources(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_BatchMigrateResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_BatchMigrateResources() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_BatchMigrateResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchMigrateResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestBatchMigrateResources(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SearchMigratableResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SearchMigratableResources() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SearchMigratableResources(context, request, response); }));
    }
    ~WithRawCallbackMethod_SearchMigratableResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SearchMigratableResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* /*request*/, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SearchMigratableResources(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_BatchMigrateResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_BatchMigrateResources() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->BatchMigrateResources(context, request, response); }));
    }
    ~WithRawCallbackMethod_BatchMigrateResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status BatchMigrateResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* BatchMigrateResources(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SearchMigratableResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SearchMigratableResources() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>* streamer) {
                       return this->StreamedSearchMigratableResources(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SearchMigratableResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SearchMigratableResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest* /*request*/, ::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSearchMigratableResources(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::SearchMigratableResourcesRequest,::google::cloud::aiplatform::v1::SearchMigratableResourcesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_BatchMigrateResources : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_BatchMigrateResources() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedBatchMigrateResources(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_BatchMigrateResources() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status BatchMigrateResources(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedBatchMigrateResources(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::BatchMigrateResourcesRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_SearchMigratableResources<WithStreamedUnaryMethod_BatchMigrateResources<Service > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_SearchMigratableResources<WithStreamedUnaryMethod_BatchMigrateResources<Service > > StreamedService;
};

}  // namespace v1
}  // namespace aiplatform
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2faiplatform_2fv1_2fmigration_5fservice_2eproto__INCLUDED
