// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/aiplatform/v1/vizier_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2faiplatform_2fv1_2fvizier_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2faiplatform_2fv1_2fvizier_5fservice_2eproto__INCLUDED

#include "google/cloud/aiplatform/v1/vizier_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace aiplatform {
namespace v1 {

// Vertex AI Vizier API.
//
// Vertex AI Vizier is a service to solve blackbox optimization problems,
// such as tuning machine learning hyperparameters and searching over deep
// learning architectures.
class VizierService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.aiplatform.v1.VizierService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a Study. A resource name will be generated after creation of the
    // Study.
    virtual ::grpc::Status CreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::google::cloud::aiplatform::v1::Study* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>> AsyncCreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>>(AsyncCreateStudyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>> PrepareAsyncCreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>>(PrepareAsyncCreateStudyRaw(context, request, cq));
    }
    // Gets a Study by name.
    virtual ::grpc::Status GetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::google::cloud::aiplatform::v1::Study* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>> AsyncGetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>>(AsyncGetStudyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>> PrepareAsyncGetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>>(PrepareAsyncGetStudyRaw(context, request, cq));
    }
    // Lists all the studies in a region for an associated project.
    virtual ::grpc::Status ListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::google::cloud::aiplatform::v1::ListStudiesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListStudiesResponse>> AsyncListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListStudiesResponse>>(AsyncListStudiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListStudiesResponse>> PrepareAsyncListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListStudiesResponse>>(PrepareAsyncListStudiesRaw(context, request, cq));
    }
    // Deletes a Study.
    virtual ::grpc::Status DeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteStudyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteStudyRaw(context, request, cq));
    }
    // Looks a study up using the user-defined display_name field instead of the
    // fully qualified resource name.
    virtual ::grpc::Status LookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::google::cloud::aiplatform::v1::Study* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>> AsyncLookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>>(AsyncLookupStudyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>> PrepareAsyncLookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>>(PrepareAsyncLookupStudyRaw(context, request, cq));
    }
    // Adds one or more Trials to a Study, with parameter values
    // suggested by Vertex AI Vizier. Returns a long-running
    // operation associated with the generation of Trial suggestions.
    // When this long-running operation succeeds, it will contain
    // a
    // [SuggestTrialsResponse][google.cloud.aiplatform.v1.SuggestTrialsResponse].
    virtual ::grpc::Status SuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncSuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncSuggestTrialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncSuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncSuggestTrialsRaw(context, request, cq));
    }
    // Adds a user provided Trial to a Study.
    virtual ::grpc::Status CreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::google::cloud::aiplatform::v1::Trial* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> AsyncCreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(AsyncCreateTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncCreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncCreateTrialRaw(context, request, cq));
    }
    // Gets a Trial.
    virtual ::grpc::Status GetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::google::cloud::aiplatform::v1::Trial* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> AsyncGetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(AsyncGetTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncGetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncGetTrialRaw(context, request, cq));
    }
    // Lists the Trials associated with a Study.
    virtual ::grpc::Status ListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::google::cloud::aiplatform::v1::ListTrialsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrialsResponse>> AsyncListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrialsResponse>>(AsyncListTrialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrialsResponse>> PrepareAsyncListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrialsResponse>>(PrepareAsyncListTrialsRaw(context, request, cq));
    }
    // Adds a measurement of the objective metrics to a Trial. This measurement
    // is assumed to have been taken before the Trial is complete.
    virtual ::grpc::Status AddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::google::cloud::aiplatform::v1::Trial* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> AsyncAddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(AsyncAddTrialMeasurementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncAddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncAddTrialMeasurementRaw(context, request, cq));
    }
    // Marks a Trial as complete.
    virtual ::grpc::Status CompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::google::cloud::aiplatform::v1::Trial* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> AsyncCompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(AsyncCompleteTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncCompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncCompleteTrialRaw(context, request, cq));
    }
    // Deletes a Trial.
    virtual ::grpc::Status DeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteTrialRaw(context, request, cq));
    }
    // Checks  whether a Trial should stop or not. Returns a
    // long-running operation. When the operation is successful,
    // it will contain a
    // [CheckTrialEarlyStoppingStateResponse][google.cloud.aiplatform.v1.CheckTrialEarlyStoppingStateResponse].
    virtual ::grpc::Status CheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCheckTrialEarlyStoppingStateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCheckTrialEarlyStoppingStateRaw(context, request, cq));
    }
    // Stops a Trial.
    virtual ::grpc::Status StopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::google::cloud::aiplatform::v1::Trial* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> AsyncStopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(AsyncStopTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncStopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncStopTrialRaw(context, request, cq));
    }
    // Lists the pareto-optimal Trials for multi-objective Study or the
    // optimal Trials for single-objective Study. The definition of
    // pareto-optimal can be checked in wiki page.
    // https://en.wikipedia.org/wiki/Pareto_efficiency
    virtual ::grpc::Status ListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>> AsyncListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>>(AsyncListOptimalTrialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>> PrepareAsyncListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>>(PrepareAsyncListOptimalTrialsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a Study. A resource name will be generated after creation of the
      // Study.
      virtual void CreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a Study by name.
      virtual void GetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists all the studies in a region for an associated project.
      virtual void ListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest* request, ::google::cloud::aiplatform::v1::ListStudiesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest* request, ::google::cloud::aiplatform::v1::ListStudiesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a Study.
      virtual void DeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Looks a study up using the user-defined display_name field instead of the
      // fully qualified resource name.
      virtual void LookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, std::function<void(::grpc::Status)>) = 0;
      virtual void LookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Adds one or more Trials to a Study, with parameter values
      // suggested by Vertex AI Vizier. Returns a long-running
      // operation associated with the generation of Trial suggestions.
      // When this long-running operation succeeds, it will contain
      // a
      // [SuggestTrialsResponse][google.cloud.aiplatform.v1.SuggestTrialsResponse].
      virtual void SuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void SuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Adds a user provided Trial to a Study.
      virtual void CreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a Trial.
      virtual void GetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Trials associated with a Study.
      virtual void ListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest* request, ::google::cloud::aiplatform::v1::ListTrialsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest* request, ::google::cloud::aiplatform::v1::ListTrialsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Adds a measurement of the objective metrics to a Trial. This measurement
      // is assumed to have been taken before the Trial is complete.
      virtual void AddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Marks a Trial as complete.
      virtual void CompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a Trial.
      virtual void DeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Checks  whether a Trial should stop or not. Returns a
      // long-running operation. When the operation is successful,
      // it will contain a
      // [CheckTrialEarlyStoppingStateResponse][google.cloud.aiplatform.v1.CheckTrialEarlyStoppingStateResponse].
      virtual void CheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Stops a Trial.
      virtual void StopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the pareto-optimal Trials for multi-objective Study or the
      // optimal Trials for single-objective Study. The definition of
      // pareto-optimal can be checked in wiki page.
      // https://en.wikipedia.org/wiki/Pareto_efficiency
      virtual void ListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* request, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* request, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>* AsyncCreateStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>* PrepareAsyncCreateStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>* AsyncGetStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>* PrepareAsyncGetStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListStudiesResponse>* AsyncListStudiesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListStudiesResponse>* PrepareAsyncListStudiesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>* AsyncLookupStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Study>* PrepareAsyncLookupStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncSuggestTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncSuggestTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* AsyncCreateTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncCreateTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* AsyncGetTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncGetTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrialsResponse>* AsyncListTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListTrialsResponse>* PrepareAsyncListTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* AsyncAddTrialMeasurementRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncAddTrialMeasurementRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* AsyncCompleteTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncCompleteTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCheckTrialEarlyStoppingStateRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCheckTrialEarlyStoppingStateRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* AsyncStopTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncStopTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>* AsyncListOptimalTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>* PrepareAsyncListOptimalTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::google::cloud::aiplatform::v1::Study* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>> AsyncCreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>>(AsyncCreateStudyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>> PrepareAsyncCreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>>(PrepareAsyncCreateStudyRaw(context, request, cq));
    }
    ::grpc::Status GetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::google::cloud::aiplatform::v1::Study* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>> AsyncGetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>>(AsyncGetStudyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>> PrepareAsyncGetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>>(PrepareAsyncGetStudyRaw(context, request, cq));
    }
    ::grpc::Status ListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::google::cloud::aiplatform::v1::ListStudiesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListStudiesResponse>> AsyncListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListStudiesResponse>>(AsyncListStudiesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListStudiesResponse>> PrepareAsyncListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListStudiesResponse>>(PrepareAsyncListStudiesRaw(context, request, cq));
    }
    ::grpc::Status DeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteStudyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteStudyRaw(context, request, cq));
    }
    ::grpc::Status LookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::google::cloud::aiplatform::v1::Study* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>> AsyncLookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>>(AsyncLookupStudyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>> PrepareAsyncLookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>>(PrepareAsyncLookupStudyRaw(context, request, cq));
    }
    ::grpc::Status SuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncSuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncSuggestTrialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncSuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncSuggestTrialsRaw(context, request, cq));
    }
    ::grpc::Status CreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::google::cloud::aiplatform::v1::Trial* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> AsyncCreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(AsyncCreateTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncCreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncCreateTrialRaw(context, request, cq));
    }
    ::grpc::Status GetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::google::cloud::aiplatform::v1::Trial* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> AsyncGetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(AsyncGetTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncGetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncGetTrialRaw(context, request, cq));
    }
    ::grpc::Status ListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::google::cloud::aiplatform::v1::ListTrialsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrialsResponse>> AsyncListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrialsResponse>>(AsyncListTrialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrialsResponse>> PrepareAsyncListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrialsResponse>>(PrepareAsyncListTrialsRaw(context, request, cq));
    }
    ::grpc::Status AddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::google::cloud::aiplatform::v1::Trial* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> AsyncAddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(AsyncAddTrialMeasurementRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncAddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncAddTrialMeasurementRaw(context, request, cq));
    }
    ::grpc::Status CompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::google::cloud::aiplatform::v1::Trial* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> AsyncCompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(AsyncCompleteTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncCompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncCompleteTrialRaw(context, request, cq));
    }
    ::grpc::Status DeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteTrialRaw(context, request, cq));
    }
    ::grpc::Status CheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCheckTrialEarlyStoppingStateRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCheckTrialEarlyStoppingStateRaw(context, request, cq));
    }
    ::grpc::Status StopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::google::cloud::aiplatform::v1::Trial* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> AsyncStopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(AsyncStopTrialRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>> PrepareAsyncStopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>>(PrepareAsyncStopTrialRaw(context, request, cq));
    }
    ::grpc::Status ListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>> AsyncListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>>(AsyncListOptimalTrialsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>> PrepareAsyncListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>>(PrepareAsyncListOptimalTrialsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, std::function<void(::grpc::Status)>) override;
      void CreateStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, std::function<void(::grpc::Status)>) override;
      void GetStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest* request, ::google::cloud::aiplatform::v1::ListStudiesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListStudies(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest* request, ::google::cloud::aiplatform::v1::ListStudiesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void LookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, std::function<void(::grpc::Status)>) override;
      void LookupStudy(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response, ::grpc::ClientUnaryReactor* reactor) override;
      void SuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void SuggestTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) override;
      void CreateTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) override;
      void GetTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest* request, ::google::cloud::aiplatform::v1::ListTrialsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest* request, ::google::cloud::aiplatform::v1::ListTrialsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) override;
      void AddTrialMeasurement(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) override;
      void CompleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CheckTrialEarlyStoppingState(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, std::function<void(::grpc::Status)>) override;
      void StopTrial(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* request, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListOptimalTrials(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* request, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>* AsyncCreateStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>* PrepareAsyncCreateStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>* AsyncGetStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>* PrepareAsyncGetStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListStudiesResponse>* AsyncListStudiesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListStudiesResponse>* PrepareAsyncListStudiesRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>* AsyncLookupStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Study>* PrepareAsyncLookupStudyRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncSuggestTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncSuggestTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* AsyncCreateTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncCreateTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* AsyncGetTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncGetTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrialsResponse>* AsyncListTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListTrialsResponse>* PrepareAsyncListTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* AsyncAddTrialMeasurementRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncAddTrialMeasurementRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* AsyncCompleteTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncCompleteTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCheckTrialEarlyStoppingStateRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCheckTrialEarlyStoppingStateRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* AsyncStopTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::Trial>* PrepareAsyncStopTrialRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>* AsyncListOptimalTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>* PrepareAsyncListOptimalTrialsRaw(::grpc::ClientContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateStudy_;
    const ::grpc::internal::RpcMethod rpcmethod_GetStudy_;
    const ::grpc::internal::RpcMethod rpcmethod_ListStudies_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteStudy_;
    const ::grpc::internal::RpcMethod rpcmethod_LookupStudy_;
    const ::grpc::internal::RpcMethod rpcmethod_SuggestTrials_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateTrial_;
    const ::grpc::internal::RpcMethod rpcmethod_GetTrial_;
    const ::grpc::internal::RpcMethod rpcmethod_ListTrials_;
    const ::grpc::internal::RpcMethod rpcmethod_AddTrialMeasurement_;
    const ::grpc::internal::RpcMethod rpcmethod_CompleteTrial_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteTrial_;
    const ::grpc::internal::RpcMethod rpcmethod_CheckTrialEarlyStoppingState_;
    const ::grpc::internal::RpcMethod rpcmethod_StopTrial_;
    const ::grpc::internal::RpcMethod rpcmethod_ListOptimalTrials_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a Study. A resource name will be generated after creation of the
    // Study.
    virtual ::grpc::Status CreateStudy(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response);
    // Gets a Study by name.
    virtual ::grpc::Status GetStudy(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response);
    // Lists all the studies in a region for an associated project.
    virtual ::grpc::Status ListStudies(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest* request, ::google::cloud::aiplatform::v1::ListStudiesResponse* response);
    // Deletes a Study.
    virtual ::grpc::Status DeleteStudy(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* request, ::google::protobuf::Empty* response);
    // Looks a study up using the user-defined display_name field instead of the
    // fully qualified resource name.
    virtual ::grpc::Status LookupStudy(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response);
    // Adds one or more Trials to a Study, with parameter values
    // suggested by Vertex AI Vizier. Returns a long-running
    // operation associated with the generation of Trial suggestions.
    // When this long-running operation succeeds, it will contain
    // a
    // [SuggestTrialsResponse][google.cloud.aiplatform.v1.SuggestTrialsResponse].
    virtual ::grpc::Status SuggestTrials(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* request, ::google::longrunning::Operation* response);
    // Adds a user provided Trial to a Study.
    virtual ::grpc::Status CreateTrial(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response);
    // Gets a Trial.
    virtual ::grpc::Status GetTrial(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response);
    // Lists the Trials associated with a Study.
    virtual ::grpc::Status ListTrials(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest* request, ::google::cloud::aiplatform::v1::ListTrialsResponse* response);
    // Adds a measurement of the objective metrics to a Trial. This measurement
    // is assumed to have been taken before the Trial is complete.
    virtual ::grpc::Status AddTrialMeasurement(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* request, ::google::cloud::aiplatform::v1::Trial* response);
    // Marks a Trial as complete.
    virtual ::grpc::Status CompleteTrial(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response);
    // Deletes a Trial.
    virtual ::grpc::Status DeleteTrial(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* request, ::google::protobuf::Empty* response);
    // Checks  whether a Trial should stop or not. Returns a
    // long-running operation. When the operation is successful,
    // it will contain a
    // [CheckTrialEarlyStoppingStateResponse][google.cloud.aiplatform.v1.CheckTrialEarlyStoppingStateResponse].
    virtual ::grpc::Status CheckTrialEarlyStoppingState(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* request, ::google::longrunning::Operation* response);
    // Stops a Trial.
    virtual ::grpc::Status StopTrial(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response);
    // Lists the pareto-optimal Trials for multi-objective Study or the
    // optimal Trials for single-objective Study. The definition of
    // pareto-optimal can be checked in wiki page.
    // https://en.wikipedia.org/wiki/Pareto_efficiency
    virtual ::grpc::Status ListOptimalTrials(::grpc::ServerContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* request, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateStudy() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateStudy(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::CreateStudyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::Study>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetStudy() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetStudy(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::GetStudyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::Study>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListStudies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListStudies() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListStudies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStudies(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListStudiesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListStudiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListStudies(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::ListStudiesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::ListStudiesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteStudy() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteStudy(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::DeleteStudyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_LookupStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_LookupStudy() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_LookupStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::LookupStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestLookupStudy(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::LookupStudyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::Study>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_SuggestTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_SuggestTrials() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_SuggestTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuggestTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSuggestTrials(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::SuggestTrialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateTrial() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_CreateTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTrial(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::CreateTrialRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::Trial>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetTrial() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTrial(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::GetTrialRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::Trial>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListTrials() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTrials(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::ListTrialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::ListTrialsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AddTrialMeasurement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AddTrialMeasurement() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_AddTrialMeasurement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddTrialMeasurement(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddTrialMeasurement(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::Trial>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CompleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CompleteTrial() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_CompleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCompleteTrial(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::CompleteTrialRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::Trial>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteTrial() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_DeleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTrial(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::DeleteTrialRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CheckTrialEarlyStoppingState : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CheckTrialEarlyStoppingState() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_CheckTrialEarlyStoppingState() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckTrialEarlyStoppingState(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCheckTrialEarlyStoppingState(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StopTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StopTrial() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_StopTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StopTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopTrial(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::StopTrialRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::Trial>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListOptimalTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListOptimalTrials() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_ListOptimalTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOptimalTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOptimalTrials(::grpc::ServerContext* context, ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateStudy<WithAsyncMethod_GetStudy<WithAsyncMethod_ListStudies<WithAsyncMethod_DeleteStudy<WithAsyncMethod_LookupStudy<WithAsyncMethod_SuggestTrials<WithAsyncMethod_CreateTrial<WithAsyncMethod_GetTrial<WithAsyncMethod_ListTrials<WithAsyncMethod_AddTrialMeasurement<WithAsyncMethod_CompleteTrial<WithAsyncMethod_DeleteTrial<WithAsyncMethod_CheckTrialEarlyStoppingState<WithAsyncMethod_StopTrial<WithAsyncMethod_ListOptimalTrials<Service > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateStudy() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreateStudyRequest, ::google::cloud::aiplatform::v1::Study>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::CreateStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response) { return this->CreateStudy(context, request, response); }));}
    void SetMessageAllocatorFor_CreateStudy(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::CreateStudyRequest, ::google::cloud::aiplatform::v1::Study>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreateStudyRequest, ::google::cloud::aiplatform::v1::Study>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateStudy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetStudy() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetStudyRequest, ::google::cloud::aiplatform::v1::Study>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::GetStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response) { return this->GetStudy(context, request, response); }));}
    void SetMessageAllocatorFor_GetStudy(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::GetStudyRequest, ::google::cloud::aiplatform::v1::Study>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetStudyRequest, ::google::cloud::aiplatform::v1::Study>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetStudy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListStudies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListStudies() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListStudiesRequest, ::google::cloud::aiplatform::v1::ListStudiesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::ListStudiesRequest* request, ::google::cloud::aiplatform::v1::ListStudiesResponse* response) { return this->ListStudies(context, request, response); }));}
    void SetMessageAllocatorFor_ListStudies(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::ListStudiesRequest, ::google::cloud::aiplatform::v1::ListStudiesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListStudiesRequest, ::google::cloud::aiplatform::v1::ListStudiesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListStudies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStudies(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListStudiesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListStudiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListStudies(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListStudiesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListStudiesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteStudy() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeleteStudyRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* request, ::google::protobuf::Empty* response) { return this->DeleteStudy(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteStudy(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::DeleteStudyRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeleteStudyRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteStudy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_LookupStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_LookupStudy() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::LookupStudyRequest, ::google::cloud::aiplatform::v1::Study>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::LookupStudyRequest* request, ::google::cloud::aiplatform::v1::Study* response) { return this->LookupStudy(context, request, response); }));}
    void SetMessageAllocatorFor_LookupStudy(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::LookupStudyRequest, ::google::cloud::aiplatform::v1::Study>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::LookupStudyRequest, ::google::cloud::aiplatform::v1::Study>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_LookupStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::LookupStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* LookupStudy(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::LookupStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_SuggestTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_SuggestTrials() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::SuggestTrialsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* request, ::google::longrunning::Operation* response) { return this->SuggestTrials(context, request, response); }));}
    void SetMessageAllocatorFor_SuggestTrials(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::SuggestTrialsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::SuggestTrialsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_SuggestTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuggestTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SuggestTrials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateTrial() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreateTrialRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::CreateTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response) { return this->CreateTrial(context, request, response); }));}
    void SetMessageAllocatorFor_CreateTrial(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::CreateTrialRequest, ::google::cloud::aiplatform::v1::Trial>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CreateTrialRequest, ::google::cloud::aiplatform::v1::Trial>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetTrial() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetTrialRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::GetTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response) { return this->GetTrial(context, request, response); }));}
    void SetMessageAllocatorFor_GetTrial(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::GetTrialRequest, ::google::cloud::aiplatform::v1::Trial>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::GetTrialRequest, ::google::cloud::aiplatform::v1::Trial>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListTrials() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListTrialsRequest, ::google::cloud::aiplatform::v1::ListTrialsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::ListTrialsRequest* request, ::google::cloud::aiplatform::v1::ListTrialsResponse* response) { return this->ListTrials(context, request, response); }));}
    void SetMessageAllocatorFor_ListTrials(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::ListTrialsRequest, ::google::cloud::aiplatform::v1::ListTrialsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListTrialsRequest, ::google::cloud::aiplatform::v1::ListTrialsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTrials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrialsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AddTrialMeasurement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AddTrialMeasurement() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* request, ::google::cloud::aiplatform::v1::Trial* response) { return this->AddTrialMeasurement(context, request, response); }));}
    void SetMessageAllocatorFor_AddTrialMeasurement(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest, ::google::cloud::aiplatform::v1::Trial>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest, ::google::cloud::aiplatform::v1::Trial>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AddTrialMeasurement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddTrialMeasurement(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddTrialMeasurement(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CompleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CompleteTrial() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CompleteTrialRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response) { return this->CompleteTrial(context, request, response); }));}
    void SetMessageAllocatorFor_CompleteTrial(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::CompleteTrialRequest, ::google::cloud::aiplatform::v1::Trial>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CompleteTrialRequest, ::google::cloud::aiplatform::v1::Trial>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CompleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CompleteTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteTrial() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeleteTrialRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* request, ::google::protobuf::Empty* response) { return this->DeleteTrial(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteTrial(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::DeleteTrialRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::DeleteTrialRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CheckTrialEarlyStoppingState : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CheckTrialEarlyStoppingState() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* request, ::google::longrunning::Operation* response) { return this->CheckTrialEarlyStoppingState(context, request, response); }));}
    void SetMessageAllocatorFor_CheckTrialEarlyStoppingState(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CheckTrialEarlyStoppingState() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckTrialEarlyStoppingState(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CheckTrialEarlyStoppingState(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StopTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StopTrial() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::StopTrialRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::StopTrialRequest* request, ::google::cloud::aiplatform::v1::Trial* response) { return this->StopTrial(context, request, response); }));}
    void SetMessageAllocatorFor_StopTrial(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::StopTrialRequest, ::google::cloud::aiplatform::v1::Trial>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::StopTrialRequest, ::google::cloud::aiplatform::v1::Trial>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StopTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StopTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StopTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListOptimalTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListOptimalTrials() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* request, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* response) { return this->ListOptimalTrials(context, request, response); }));}
    void SetMessageAllocatorFor_ListOptimalTrials(
        ::grpc::MessageAllocator< ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListOptimalTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOptimalTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOptimalTrials(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateStudy<WithCallbackMethod_GetStudy<WithCallbackMethod_ListStudies<WithCallbackMethod_DeleteStudy<WithCallbackMethod_LookupStudy<WithCallbackMethod_SuggestTrials<WithCallbackMethod_CreateTrial<WithCallbackMethod_GetTrial<WithCallbackMethod_ListTrials<WithCallbackMethod_AddTrialMeasurement<WithCallbackMethod_CompleteTrial<WithCallbackMethod_DeleteTrial<WithCallbackMethod_CheckTrialEarlyStoppingState<WithCallbackMethod_StopTrial<WithCallbackMethod_ListOptimalTrials<Service > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateStudy() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetStudy() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListStudies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListStudies() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListStudies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStudies(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListStudiesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListStudiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteStudy() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_LookupStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_LookupStudy() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_LookupStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::LookupStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_SuggestTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_SuggestTrials() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_SuggestTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuggestTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateTrial() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_CreateTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetTrial() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListTrials() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AddTrialMeasurement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AddTrialMeasurement() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_AddTrialMeasurement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddTrialMeasurement(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CompleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CompleteTrial() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_CompleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteTrial() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_DeleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CheckTrialEarlyStoppingState : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CheckTrialEarlyStoppingState() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_CheckTrialEarlyStoppingState() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckTrialEarlyStoppingState(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StopTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StopTrial() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_StopTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StopTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListOptimalTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListOptimalTrials() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_ListOptimalTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOptimalTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateStudy() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateStudy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetStudy() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetStudy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListStudies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListStudies() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListStudies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStudies(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListStudiesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListStudiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListStudies(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteStudy() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteStudy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_LookupStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_LookupStudy() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_LookupStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::LookupStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestLookupStudy(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_SuggestTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_SuggestTrials() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_SuggestTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuggestTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestSuggestTrials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateTrial() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_CreateTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateTrial(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetTrial() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetTrial(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListTrials() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListTrials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AddTrialMeasurement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AddTrialMeasurement() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_AddTrialMeasurement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddTrialMeasurement(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddTrialMeasurement(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CompleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CompleteTrial() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_CompleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCompleteTrial(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteTrial() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_DeleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteTrial(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CheckTrialEarlyStoppingState : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CheckTrialEarlyStoppingState() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_CheckTrialEarlyStoppingState() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckTrialEarlyStoppingState(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCheckTrialEarlyStoppingState(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StopTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StopTrial() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_StopTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StopTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopTrial(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListOptimalTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListOptimalTrials() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_ListOptimalTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOptimalTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListOptimalTrials(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateStudy() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateStudy(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateStudy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetStudy() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetStudy(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetStudy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListStudies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListStudies() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListStudies(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListStudies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListStudies(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListStudiesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListStudiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListStudies(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteStudy() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteStudy(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteStudy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_LookupStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_LookupStudy() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->LookupStudy(context, request, response); }));
    }
    ~WithRawCallbackMethod_LookupStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status LookupStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::LookupStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* LookupStudy(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_SuggestTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_SuggestTrials() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->SuggestTrials(context, request, response); }));
    }
    ~WithRawCallbackMethod_SuggestTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status SuggestTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* SuggestTrials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateTrial() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateTrial(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetTrial() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetTrial(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListTrials() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListTrials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListTrials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AddTrialMeasurement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AddTrialMeasurement() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AddTrialMeasurement(context, request, response); }));
    }
    ~WithRawCallbackMethod_AddTrialMeasurement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddTrialMeasurement(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddTrialMeasurement(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CompleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CompleteTrial() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CompleteTrial(context, request, response); }));
    }
    ~WithRawCallbackMethod_CompleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CompleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CompleteTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteTrial() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteTrial(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CheckTrialEarlyStoppingState : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CheckTrialEarlyStoppingState() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CheckTrialEarlyStoppingState(context, request, response); }));
    }
    ~WithRawCallbackMethod_CheckTrialEarlyStoppingState() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CheckTrialEarlyStoppingState(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CheckTrialEarlyStoppingState(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StopTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StopTrial() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StopTrial(context, request, response); }));
    }
    ~WithRawCallbackMethod_StopTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StopTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopTrial(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListOptimalTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListOptimalTrials() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListOptimalTrials(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListOptimalTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListOptimalTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListOptimalTrials(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateStudy() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::CreateStudyRequest, ::google::cloud::aiplatform::v1::Study>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::CreateStudyRequest, ::google::cloud::aiplatform::v1::Study>* streamer) {
                       return this->StreamedCreateStudy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateStudy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::CreateStudyRequest,::google::cloud::aiplatform::v1::Study>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetStudy() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::GetStudyRequest, ::google::cloud::aiplatform::v1::Study>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::GetStudyRequest, ::google::cloud::aiplatform::v1::Study>* streamer) {
                       return this->StreamedGetStudy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetStudy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::GetStudyRequest,::google::cloud::aiplatform::v1::Study>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListStudies : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListStudies() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::ListStudiesRequest, ::google::cloud::aiplatform::v1::ListStudiesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::ListStudiesRequest, ::google::cloud::aiplatform::v1::ListStudiesResponse>* streamer) {
                       return this->StreamedListStudies(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListStudies() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListStudies(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListStudiesRequest* /*request*/, ::google::cloud::aiplatform::v1::ListStudiesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListStudies(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::ListStudiesRequest,::google::cloud::aiplatform::v1::ListStudiesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteStudy() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::DeleteStudyRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::DeleteStudyRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteStudy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteStudyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteStudy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::DeleteStudyRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_LookupStudy : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_LookupStudy() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::LookupStudyRequest, ::google::cloud::aiplatform::v1::Study>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::LookupStudyRequest, ::google::cloud::aiplatform::v1::Study>* streamer) {
                       return this->StreamedLookupStudy(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_LookupStudy() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status LookupStudy(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::LookupStudyRequest* /*request*/, ::google::cloud::aiplatform::v1::Study* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedLookupStudy(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::LookupStudyRequest,::google::cloud::aiplatform::v1::Study>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_SuggestTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_SuggestTrials() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::SuggestTrialsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::SuggestTrialsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedSuggestTrials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_SuggestTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status SuggestTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::SuggestTrialsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedSuggestTrials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::SuggestTrialsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateTrial() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::CreateTrialRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::CreateTrialRequest, ::google::cloud::aiplatform::v1::Trial>* streamer) {
                       return this->StreamedCreateTrial(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CreateTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateTrial(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::CreateTrialRequest,::google::cloud::aiplatform::v1::Trial>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetTrial() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::GetTrialRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::GetTrialRequest, ::google::cloud::aiplatform::v1::Trial>* streamer) {
                       return this->StreamedGetTrial(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::GetTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetTrial(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::GetTrialRequest,::google::cloud::aiplatform::v1::Trial>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListTrials() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::ListTrialsRequest, ::google::cloud::aiplatform::v1::ListTrialsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::ListTrialsRequest, ::google::cloud::aiplatform::v1::ListTrialsResponse>* streamer) {
                       return this->StreamedListTrials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListTrials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::ListTrialsRequest,::google::cloud::aiplatform::v1::ListTrialsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AddTrialMeasurement : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AddTrialMeasurement() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest, ::google::cloud::aiplatform::v1::Trial>* streamer) {
                       return this->StreamedAddTrialMeasurement(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AddTrialMeasurement() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AddTrialMeasurement(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAddTrialMeasurement(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::AddTrialMeasurementRequest,::google::cloud::aiplatform::v1::Trial>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CompleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CompleteTrial() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::CompleteTrialRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::CompleteTrialRequest, ::google::cloud::aiplatform::v1::Trial>* streamer) {
                       return this->StreamedCompleteTrial(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CompleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CompleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CompleteTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCompleteTrial(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::CompleteTrialRequest,::google::cloud::aiplatform::v1::Trial>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteTrial() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::DeleteTrialRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::DeleteTrialRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteTrial(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::DeleteTrialRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteTrial(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::DeleteTrialRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CheckTrialEarlyStoppingState : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CheckTrialEarlyStoppingState() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCheckTrialEarlyStoppingState(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CheckTrialEarlyStoppingState() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CheckTrialEarlyStoppingState(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCheckTrialEarlyStoppingState(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::CheckTrialEarlyStoppingStateRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StopTrial : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StopTrial() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::StopTrialRequest, ::google::cloud::aiplatform::v1::Trial>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::StopTrialRequest, ::google::cloud::aiplatform::v1::Trial>* streamer) {
                       return this->StreamedStopTrial(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StopTrial() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StopTrial(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::StopTrialRequest* /*request*/, ::google::cloud::aiplatform::v1::Trial* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStopTrial(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::StopTrialRequest,::google::cloud::aiplatform::v1::Trial>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListOptimalTrials : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListOptimalTrials() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>* streamer) {
                       return this->StreamedListOptimalTrials(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListOptimalTrials() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListOptimalTrials(::grpc::ServerContext* /*context*/, const ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest* /*request*/, ::google::cloud::aiplatform::v1::ListOptimalTrialsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListOptimalTrials(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::aiplatform::v1::ListOptimalTrialsRequest,::google::cloud::aiplatform::v1::ListOptimalTrialsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateStudy<WithStreamedUnaryMethod_GetStudy<WithStreamedUnaryMethod_ListStudies<WithStreamedUnaryMethod_DeleteStudy<WithStreamedUnaryMethod_LookupStudy<WithStreamedUnaryMethod_SuggestTrials<WithStreamedUnaryMethod_CreateTrial<WithStreamedUnaryMethod_GetTrial<WithStreamedUnaryMethod_ListTrials<WithStreamedUnaryMethod_AddTrialMeasurement<WithStreamedUnaryMethod_CompleteTrial<WithStreamedUnaryMethod_DeleteTrial<WithStreamedUnaryMethod_CheckTrialEarlyStoppingState<WithStreamedUnaryMethod_StopTrial<WithStreamedUnaryMethod_ListOptimalTrials<Service > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateStudy<WithStreamedUnaryMethod_GetStudy<WithStreamedUnaryMethod_ListStudies<WithStreamedUnaryMethod_DeleteStudy<WithStreamedUnaryMethod_LookupStudy<WithStreamedUnaryMethod_SuggestTrials<WithStreamedUnaryMethod_CreateTrial<WithStreamedUnaryMethod_GetTrial<WithStreamedUnaryMethod_ListTrials<WithStreamedUnaryMethod_AddTrialMeasurement<WithStreamedUnaryMethod_CompleteTrial<WithStreamedUnaryMethod_DeleteTrial<WithStreamedUnaryMethod_CheckTrialEarlyStoppingState<WithStreamedUnaryMethod_StopTrial<WithStreamedUnaryMethod_ListOptimalTrials<Service > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace aiplatform
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2faiplatform_2fv1_2fvizier_5fservice_2eproto__INCLUDED
