// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/channel/v1/reports_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fchannel_2fv1_2freports_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fchannel_2fv1_2freports_5fservice_2eproto__INCLUDED

#include "google/cloud/channel/v1/reports_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace channel {
namespace v1 {

// CloudChannelReportsService lets Google Cloud resellers and
// distributors retrieve and combine a variety of data in Cloud Channel for
// multiple products (Google Cloud, Google Voice, and Google Workspace.)
//
// Deprecated: This service is being deprecated. Please use [Export Channel
// Services data to
// BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
// instead.
class CloudChannelReportsService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.channel.v1.CloudChannelReportsService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Begins generation of data for a given report. The report
    // identifier is a UID (for example, `613bf59q`).
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The user doesn't have access to this report.
    // * INVALID_ARGUMENT: Required request parameters are missing
    //   or invalid.
    // * NOT_FOUND: The report identifier was not found.
    // * INTERNAL: Any non-user error related to a technical issue
    //   in the backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue
    //   in the backend. Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata contains an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    //
    // To get the results of report generation, call
    // [CloudChannelReportsService.FetchReportResults][google.cloud.channel.v1.CloudChannelReportsService.FetchReportResults]
    // with the
    // [RunReportJobResponse.report_job][google.cloud.channel.v1.RunReportJobResponse.report_job].
    //
    // Deprecated: Please use [Export Channel Services data to
    // BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
    // instead.
    virtual ::grpc::Status RunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRunReportJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRunReportJobRaw(context, request, cq));
    }
    // Retrieves data generated by
    // [CloudChannelReportsService.RunReportJob][google.cloud.channel.v1.CloudChannelReportsService.RunReportJob].
    //
    // Deprecated: Please use [Export Channel Services data to
    // BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
    // instead.
    virtual ::grpc::Status FetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::google::cloud::channel::v1::FetchReportResultsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::FetchReportResultsResponse>> AsyncFetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::FetchReportResultsResponse>>(AsyncFetchReportResultsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::FetchReportResultsResponse>> PrepareAsyncFetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::FetchReportResultsResponse>>(PrepareAsyncFetchReportResultsRaw(context, request, cq));
    }
    // Lists the reports that RunReportJob can run. These reports include an ID,
    // a description, and the list of columns that will be in the result.
    //
    // Deprecated: Please use [Export Channel Services data to
    // BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
    // instead.
    virtual ::grpc::Status ListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::google::cloud::channel::v1::ListReportsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListReportsResponse>> AsyncListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListReportsResponse>>(AsyncListReportsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListReportsResponse>> PrepareAsyncListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListReportsResponse>>(PrepareAsyncListReportsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Begins generation of data for a given report. The report
      // identifier is a UID (for example, `613bf59q`).
      //
      // Possible error codes:
      //
      // * PERMISSION_DENIED: The user doesn't have access to this report.
      // * INVALID_ARGUMENT: Required request parameters are missing
      //   or invalid.
      // * NOT_FOUND: The report identifier was not found.
      // * INTERNAL: Any non-user error related to a technical issue
      //   in the backend. Contact Cloud Channel support.
      // * UNKNOWN: Any non-user error related to a technical issue
      //   in the backend. Contact Cloud Channel support.
      //
      // Return value:
      // The ID of a long-running operation.
      //
      // To get the results of the operation, call the GetOperation method of
      // CloudChannelOperationsService. The Operation metadata contains an
      // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
      //
      // To get the results of report generation, call
      // [CloudChannelReportsService.FetchReportResults][google.cloud.channel.v1.CloudChannelReportsService.FetchReportResults]
      // with the
      // [RunReportJobResponse.report_job][google.cloud.channel.v1.RunReportJobResponse.report_job].
      //
      // Deprecated: Please use [Export Channel Services data to
      // BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
      // instead.
      virtual void RunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves data generated by
      // [CloudChannelReportsService.RunReportJob][google.cloud.channel.v1.CloudChannelReportsService.RunReportJob].
      //
      // Deprecated: Please use [Export Channel Services data to
      // BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
      // instead.
      virtual void FetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest* request, ::google::cloud::channel::v1::FetchReportResultsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void FetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest* request, ::google::cloud::channel::v1::FetchReportResultsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the reports that RunReportJob can run. These reports include an ID,
      // a description, and the list of columns that will be in the result.
      //
      // Deprecated: Please use [Export Channel Services data to
      // BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
      // instead.
      virtual void ListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest* request, ::google::cloud::channel::v1::ListReportsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest* request, ::google::cloud::channel::v1::ListReportsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRunReportJobRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRunReportJobRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::FetchReportResultsResponse>* AsyncFetchReportResultsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::FetchReportResultsResponse>* PrepareAsyncFetchReportResultsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListReportsResponse>* AsyncListReportsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::channel::v1::ListReportsResponse>* PrepareAsyncListReportsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status RunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRunReportJobRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRunReportJobRaw(context, request, cq));
    }
    ::grpc::Status FetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::google::cloud::channel::v1::FetchReportResultsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::FetchReportResultsResponse>> AsyncFetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::FetchReportResultsResponse>>(AsyncFetchReportResultsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::FetchReportResultsResponse>> PrepareAsyncFetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::FetchReportResultsResponse>>(PrepareAsyncFetchReportResultsRaw(context, request, cq));
    }
    ::grpc::Status ListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::google::cloud::channel::v1::ListReportsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListReportsResponse>> AsyncListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListReportsResponse>>(AsyncListReportsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListReportsResponse>> PrepareAsyncListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListReportsResponse>>(PrepareAsyncListReportsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void RunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RunReportJob(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void FetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest* request, ::google::cloud::channel::v1::FetchReportResultsResponse* response, std::function<void(::grpc::Status)>) override;
      void FetchReportResults(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest* request, ::google::cloud::channel::v1::FetchReportResultsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest* request, ::google::cloud::channel::v1::ListReportsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListReports(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest* request, ::google::cloud::channel::v1::ListReportsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRunReportJobRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRunReportJobRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::RunReportJobRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::FetchReportResultsResponse>* AsyncFetchReportResultsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::FetchReportResultsResponse>* PrepareAsyncFetchReportResultsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListReportsResponse>* AsyncListReportsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::channel::v1::ListReportsResponse>* PrepareAsyncListReportsRaw(::grpc::ClientContext* context, const ::google::cloud::channel::v1::ListReportsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_RunReportJob_;
    const ::grpc::internal::RpcMethod rpcmethod_FetchReportResults_;
    const ::grpc::internal::RpcMethod rpcmethod_ListReports_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Begins generation of data for a given report. The report
    // identifier is a UID (for example, `613bf59q`).
    //
    // Possible error codes:
    //
    // * PERMISSION_DENIED: The user doesn't have access to this report.
    // * INVALID_ARGUMENT: Required request parameters are missing
    //   or invalid.
    // * NOT_FOUND: The report identifier was not found.
    // * INTERNAL: Any non-user error related to a technical issue
    //   in the backend. Contact Cloud Channel support.
    // * UNKNOWN: Any non-user error related to a technical issue
    //   in the backend. Contact Cloud Channel support.
    //
    // Return value:
    // The ID of a long-running operation.
    //
    // To get the results of the operation, call the GetOperation method of
    // CloudChannelOperationsService. The Operation metadata contains an
    // instance of [OperationMetadata][google.cloud.channel.v1.OperationMetadata].
    //
    // To get the results of report generation, call
    // [CloudChannelReportsService.FetchReportResults][google.cloud.channel.v1.CloudChannelReportsService.FetchReportResults]
    // with the
    // [RunReportJobResponse.report_job][google.cloud.channel.v1.RunReportJobResponse.report_job].
    //
    // Deprecated: Please use [Export Channel Services data to
    // BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
    // instead.
    virtual ::grpc::Status RunReportJob(::grpc::ServerContext* context, const ::google::cloud::channel::v1::RunReportJobRequest* request, ::google::longrunning::Operation* response);
    // Retrieves data generated by
    // [CloudChannelReportsService.RunReportJob][google.cloud.channel.v1.CloudChannelReportsService.RunReportJob].
    //
    // Deprecated: Please use [Export Channel Services data to
    // BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
    // instead.
    virtual ::grpc::Status FetchReportResults(::grpc::ServerContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest* request, ::google::cloud::channel::v1::FetchReportResultsResponse* response);
    // Lists the reports that RunReportJob can run. These reports include an ID,
    // a description, and the list of columns that will be in the result.
    //
    // Deprecated: Please use [Export Channel Services data to
    // BigQuery](https://cloud.google.com/channel/docs/rebilling/export-data-to-bigquery)
    // instead.
    virtual ::grpc::Status ListReports(::grpc::ServerContext* context, const ::google::cloud::channel::v1::ListReportsRequest* request, ::google::cloud::channel::v1::ListReportsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_RunReportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RunReportJob() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_RunReportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunReportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RunReportJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRunReportJob(::grpc::ServerContext* context, ::google::cloud::channel::v1::RunReportJobRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_FetchReportResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_FetchReportResults() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_FetchReportResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchReportResults(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::FetchReportResultsRequest* /*request*/, ::google::cloud::channel::v1::FetchReportResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchReportResults(::grpc::ServerContext* context, ::google::cloud::channel::v1::FetchReportResultsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::FetchReportResultsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListReports() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReports(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListReportsRequest* /*request*/, ::google::cloud::channel::v1::ListReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReports(::grpc::ServerContext* context, ::google::cloud::channel::v1::ListReportsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::channel::v1::ListReportsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_RunReportJob<WithAsyncMethod_FetchReportResults<WithAsyncMethod_ListReports<Service > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_RunReportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RunReportJob() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::RunReportJobRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::RunReportJobRequest* request, ::google::longrunning::Operation* response) { return this->RunReportJob(context, request, response); }));}
    void SetMessageAllocatorFor_RunReportJob(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::RunReportJobRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::RunReportJobRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RunReportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunReportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RunReportJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RunReportJob(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::RunReportJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_FetchReportResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_FetchReportResults() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::FetchReportResultsRequest, ::google::cloud::channel::v1::FetchReportResultsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::FetchReportResultsRequest* request, ::google::cloud::channel::v1::FetchReportResultsResponse* response) { return this->FetchReportResults(context, request, response); }));}
    void SetMessageAllocatorFor_FetchReportResults(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::FetchReportResultsRequest, ::google::cloud::channel::v1::FetchReportResultsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::FetchReportResultsRequest, ::google::cloud::channel::v1::FetchReportResultsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_FetchReportResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchReportResults(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::FetchReportResultsRequest* /*request*/, ::google::cloud::channel::v1::FetchReportResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchReportResults(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::FetchReportResultsRequest* /*request*/, ::google::cloud::channel::v1::FetchReportResultsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListReports() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListReportsRequest, ::google::cloud::channel::v1::ListReportsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::channel::v1::ListReportsRequest* request, ::google::cloud::channel::v1::ListReportsResponse* response) { return this->ListReports(context, request, response); }));}
    void SetMessageAllocatorFor_ListReports(
        ::grpc::MessageAllocator< ::google::cloud::channel::v1::ListReportsRequest, ::google::cloud::channel::v1::ListReportsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::channel::v1::ListReportsRequest, ::google::cloud::channel::v1::ListReportsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReports(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListReportsRequest* /*request*/, ::google::cloud::channel::v1::ListReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReports(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::channel::v1::ListReportsRequest* /*request*/, ::google::cloud::channel::v1::ListReportsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_RunReportJob<WithCallbackMethod_FetchReportResults<WithCallbackMethod_ListReports<Service > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_RunReportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RunReportJob() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_RunReportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunReportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RunReportJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_FetchReportResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_FetchReportResults() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_FetchReportResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchReportResults(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::FetchReportResultsRequest* /*request*/, ::google::cloud::channel::v1::FetchReportResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListReports() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReports(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListReportsRequest* /*request*/, ::google::cloud::channel::v1::ListReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_RunReportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RunReportJob() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_RunReportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunReportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RunReportJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRunReportJob(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_FetchReportResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_FetchReportResults() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_FetchReportResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchReportResults(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::FetchReportResultsRequest* /*request*/, ::google::cloud::channel::v1::FetchReportResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestFetchReportResults(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListReports() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReports(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListReportsRequest* /*request*/, ::google::cloud::channel::v1::ListReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReports(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RunReportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RunReportJob() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RunReportJob(context, request, response); }));
    }
    ~WithRawCallbackMethod_RunReportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RunReportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RunReportJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RunReportJob(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_FetchReportResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_FetchReportResults() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->FetchReportResults(context, request, response); }));
    }
    ~WithRawCallbackMethod_FetchReportResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status FetchReportResults(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::FetchReportResultsRequest* /*request*/, ::google::cloud::channel::v1::FetchReportResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* FetchReportResults(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListReports() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListReports(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReports(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListReportsRequest* /*request*/, ::google::cloud::channel::v1::ListReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReports(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RunReportJob : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RunReportJob() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::RunReportJobRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::RunReportJobRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRunReportJob(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RunReportJob() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RunReportJob(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::RunReportJobRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRunReportJob(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::RunReportJobRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_FetchReportResults : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_FetchReportResults() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::FetchReportResultsRequest, ::google::cloud::channel::v1::FetchReportResultsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::FetchReportResultsRequest, ::google::cloud::channel::v1::FetchReportResultsResponse>* streamer) {
                       return this->StreamedFetchReportResults(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_FetchReportResults() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status FetchReportResults(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::FetchReportResultsRequest* /*request*/, ::google::cloud::channel::v1::FetchReportResultsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedFetchReportResults(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::FetchReportResultsRequest,::google::cloud::channel::v1::FetchReportResultsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListReports : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListReports() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::channel::v1::ListReportsRequest, ::google::cloud::channel::v1::ListReportsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::channel::v1::ListReportsRequest, ::google::cloud::channel::v1::ListReportsResponse>* streamer) {
                       return this->StreamedListReports(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListReports() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListReports(::grpc::ServerContext* /*context*/, const ::google::cloud::channel::v1::ListReportsRequest* /*request*/, ::google::cloud::channel::v1::ListReportsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListReports(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::channel::v1::ListReportsRequest,::google::cloud::channel::v1::ListReportsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_RunReportJob<WithStreamedUnaryMethod_FetchReportResults<WithStreamedUnaryMethod_ListReports<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_RunReportJob<WithStreamedUnaryMethod_FetchReportResults<WithStreamedUnaryMethod_ListReports<Service > > > StreamedService;
};

}  // namespace v1
}  // namespace channel
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fchannel_2fv1_2freports_5fservice_2eproto__INCLUDED
