// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/compute/http_health_checks/v1/http_health_checks.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HTTP_HEALTH_CHECKS_V1_HTTP_HEALTH_CHECKS_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HTTP_HEALTH_CHECKS_V1_HTTP_HEALTH_CHECKS_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/compute/http_health_checks/v1/http_health_checks.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace compute_http_health_checks_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class HttpHealthChecksConnectionIdempotencyPolicy {
 public:
  virtual ~HttpHealthChecksConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<HttpHealthChecksConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency DeleteHttpHealthCheck(
      google::cloud::cpp::compute::http_health_checks::v1::
          DeleteHttpHealthCheckRequest const& request);

  virtual google::cloud::Idempotency GetHttpHealthCheck(
      google::cloud::cpp::compute::http_health_checks::v1::
          GetHttpHealthCheckRequest const& request);

  virtual google::cloud::Idempotency InsertHttpHealthCheck(
      google::cloud::cpp::compute::http_health_checks::v1::
          InsertHttpHealthCheckRequest const& request);

  virtual google::cloud::Idempotency ListHttpHealthChecks(
      google::cloud::cpp::compute::http_health_checks::v1::
          ListHttpHealthChecksRequest request);

  virtual google::cloud::Idempotency PatchHttpHealthCheck(
      google::cloud::cpp::compute::http_health_checks::v1::
          PatchHttpHealthCheckRequest const& request);

  virtual google::cloud::Idempotency UpdateHttpHealthCheck(
      google::cloud::cpp::compute::http_health_checks::v1::
          UpdateHttpHealthCheckRequest const& request);
};

std::unique_ptr<HttpHealthChecksConnectionIdempotencyPolicy>
MakeDefaultHttpHealthChecksConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace compute_http_health_checks_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_COMPUTE_HTTP_HEALTH_CHECKS_V1_HTTP_HEALTH_CHECKS_CONNECTION_IDEMPOTENCY_POLICY_H
