// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/dialogflow/v2/conversation_model.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fdialogflow_2fv2_2fconversation_5fmodel_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fdialogflow_2fv2_2fconversation_5fmodel_2eproto__INCLUDED

#include "google/cloud/dialogflow/v2/conversation_model.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace dialogflow {
namespace v2 {

// Manages a collection of models for human agent assistant.
class ConversationModels final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.dialogflow.v2.ConversationModels";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a model.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [CreateConversationModelOperationMetadata][google.cloud.dialogflow.v2.CreateConversationModelOperationMetadata]
    // - `response`:
    // [ConversationModel][google.cloud.dialogflow.v2.ConversationModel]
    virtual ::grpc::Status CreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateConversationModelRaw(context, request, cq));
    }
    // Gets conversation model.
    virtual ::grpc::Status GetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::google::cloud::dialogflow::v2::ConversationModel* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModel>> AsyncGetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModel>>(AsyncGetConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModel>> PrepareAsyncGetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModel>>(PrepareAsyncGetConversationModelRaw(context, request, cq));
    }
    // Lists conversation models.
    virtual ::grpc::Status ListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>> AsyncListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>>(AsyncListConversationModelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>> PrepareAsyncListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>>(PrepareAsyncListConversationModelsRaw(context, request, cq));
    }
    // Deletes a model.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [DeleteConversationModelOperationMetadata][google.cloud.dialogflow.v2.DeleteConversationModelOperationMetadata]
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    virtual ::grpc::Status DeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteConversationModelRaw(context, request, cq));
    }
    // Deploys a model. If a model is already deployed, deploying it
    // has no effect. A model can only serve prediction requests after it gets
    // deployed. For article suggestion, custom model will not be used unless
    // it is deployed.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [DeployConversationModelOperationMetadata][google.cloud.dialogflow.v2.DeployConversationModelOperationMetadata]
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    virtual ::grpc::Status DeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeployConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeployConversationModelRaw(context, request, cq));
    }
    // Undeploys a model. If the model is not deployed this method has no effect.
    // If the model is currently being used:
    //   - For article suggestion, article suggestion will fallback to the default
    //     model if model is undeployed.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [UndeployConversationModelOperationMetadata][google.cloud.dialogflow.v2.UndeployConversationModelOperationMetadata]
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    virtual ::grpc::Status UndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUndeployConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUndeployConversationModelRaw(context, request, cq));
    }
    // Gets an evaluation of conversation model.
    virtual ::grpc::Status GetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>> AsyncGetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>>(AsyncGetConversationModelEvaluationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>> PrepareAsyncGetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>>(PrepareAsyncGetConversationModelEvaluationRaw(context, request, cq));
    }
    // Lists evaluations of a conversation model.
    virtual ::grpc::Status ListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>> AsyncListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>>(AsyncListConversationModelEvaluationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>> PrepareAsyncListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>>(PrepareAsyncListConversationModelEvaluationsRaw(context, request, cq));
    }
    // Creates evaluation of a conversation model.
    virtual ::grpc::Status CreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateConversationModelEvaluationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateConversationModelEvaluationRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a model.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [CreateConversationModelOperationMetadata][google.cloud.dialogflow.v2.CreateConversationModelOperationMetadata]
      // - `response`:
      // [ConversationModel][google.cloud.dialogflow.v2.ConversationModel]
      virtual void CreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets conversation model.
      virtual void GetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* request, ::google::cloud::dialogflow::v2::ConversationModel* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* request, ::google::cloud::dialogflow::v2::ConversationModel* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists conversation models.
      virtual void ListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a model.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [DeleteConversationModelOperationMetadata][google.cloud.dialogflow.v2.DeleteConversationModelOperationMetadata]
      // - `response`: An [Empty
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
      virtual void DeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deploys a model. If a model is already deployed, deploying it
      // has no effect. A model can only serve prediction requests after it gets
      // deployed. For article suggestion, custom model will not be used unless
      // it is deployed.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [DeployConversationModelOperationMetadata][google.cloud.dialogflow.v2.DeployConversationModelOperationMetadata]
      // - `response`: An [Empty
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
      virtual void DeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Undeploys a model. If the model is not deployed this method has no effect.
      // If the model is currently being used:
      //   - For article suggestion, article suggestion will fallback to the default
      //     model if model is undeployed.
      //
      // This method is a [long-running
      // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
      // The returned `Operation` type has the following method-specific fields:
      //
      // - `metadata`:
      // [UndeployConversationModelOperationMetadata][google.cloud.dialogflow.v2.UndeployConversationModelOperationMetadata]
      // - `response`: An [Empty
      //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
      virtual void UndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets an evaluation of conversation model.
      virtual void GetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* request, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* request, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists evaluations of a conversation model.
      virtual void ListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates evaluation of a conversation model.
      virtual void CreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModel>* AsyncGetConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModel>* PrepareAsyncGetConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>* AsyncListConversationModelsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>* PrepareAsyncListConversationModelsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeployConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeployConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUndeployConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUndeployConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>* AsyncGetConversationModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>* PrepareAsyncGetConversationModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>* AsyncListConversationModelEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>* PrepareAsyncListConversationModelEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateConversationModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateConversationModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateConversationModelRaw(context, request, cq));
    }
    ::grpc::Status GetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::google::cloud::dialogflow::v2::ConversationModel* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModel>> AsyncGetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModel>>(AsyncGetConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModel>> PrepareAsyncGetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModel>>(PrepareAsyncGetConversationModelRaw(context, request, cq));
    }
    ::grpc::Status ListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>> AsyncListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>>(AsyncListConversationModelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>> PrepareAsyncListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>>(PrepareAsyncListConversationModelsRaw(context, request, cq));
    }
    ::grpc::Status DeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteConversationModelRaw(context, request, cq));
    }
    ::grpc::Status DeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeployConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeployConversationModelRaw(context, request, cq));
    }
    ::grpc::Status UndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUndeployConversationModelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUndeployConversationModelRaw(context, request, cq));
    }
    ::grpc::Status GetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>> AsyncGetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>>(AsyncGetConversationModelEvaluationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>> PrepareAsyncGetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>>(PrepareAsyncGetConversationModelEvaluationRaw(context, request, cq));
    }
    ::grpc::Status ListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>> AsyncListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>>(AsyncListConversationModelEvaluationsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>> PrepareAsyncListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>>(PrepareAsyncListConversationModelEvaluationsRaw(context, request, cq));
    }
    ::grpc::Status CreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateConversationModelEvaluationRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateConversationModelEvaluationRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* request, ::google::cloud::dialogflow::v2::ConversationModel* response, std::function<void(::grpc::Status)>) override;
      void GetConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* request, ::google::cloud::dialogflow::v2::ConversationModel* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListConversationModels(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UndeployConversationModel(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* request, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* response, std::function<void(::grpc::Status)>) override;
      void GetConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* request, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListConversationModelEvaluations(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateConversationModelEvaluation(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModel>* AsyncGetConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModel>* PrepareAsyncGetConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>* AsyncListConversationModelsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>* PrepareAsyncListConversationModelsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeployConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeployConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUndeployConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUndeployConversationModelRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>* AsyncGetConversationModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>* PrepareAsyncGetConversationModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>* AsyncListConversationModelEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>* PrepareAsyncListConversationModelEvaluationsRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateConversationModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateConversationModelEvaluationRaw(::grpc::ClientContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateConversationModel_;
    const ::grpc::internal::RpcMethod rpcmethod_GetConversationModel_;
    const ::grpc::internal::RpcMethod rpcmethod_ListConversationModels_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteConversationModel_;
    const ::grpc::internal::RpcMethod rpcmethod_DeployConversationModel_;
    const ::grpc::internal::RpcMethod rpcmethod_UndeployConversationModel_;
    const ::grpc::internal::RpcMethod rpcmethod_GetConversationModelEvaluation_;
    const ::grpc::internal::RpcMethod rpcmethod_ListConversationModelEvaluations_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateConversationModelEvaluation_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a model.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [CreateConversationModelOperationMetadata][google.cloud.dialogflow.v2.CreateConversationModelOperationMetadata]
    // - `response`:
    // [ConversationModel][google.cloud.dialogflow.v2.ConversationModel]
    virtual ::grpc::Status CreateConversationModel(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* request, ::google::longrunning::Operation* response);
    // Gets conversation model.
    virtual ::grpc::Status GetConversationModel(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* request, ::google::cloud::dialogflow::v2::ConversationModel* response);
    // Lists conversation models.
    virtual ::grpc::Status ListConversationModels(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* response);
    // Deletes a model.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [DeleteConversationModelOperationMetadata][google.cloud.dialogflow.v2.DeleteConversationModelOperationMetadata]
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    virtual ::grpc::Status DeleteConversationModel(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* request, ::google::longrunning::Operation* response);
    // Deploys a model. If a model is already deployed, deploying it
    // has no effect. A model can only serve prediction requests after it gets
    // deployed. For article suggestion, custom model will not be used unless
    // it is deployed.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [DeployConversationModelOperationMetadata][google.cloud.dialogflow.v2.DeployConversationModelOperationMetadata]
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    virtual ::grpc::Status DeployConversationModel(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* request, ::google::longrunning::Operation* response);
    // Undeploys a model. If the model is not deployed this method has no effect.
    // If the model is currently being used:
    //   - For article suggestion, article suggestion will fallback to the default
    //     model if model is undeployed.
    //
    // This method is a [long-running
    // operation](https://cloud.google.com/dialogflow/es/docs/how/long-running-operations).
    // The returned `Operation` type has the following method-specific fields:
    //
    // - `metadata`:
    // [UndeployConversationModelOperationMetadata][google.cloud.dialogflow.v2.UndeployConversationModelOperationMetadata]
    // - `response`: An [Empty
    //   message](https://developers.google.com/protocol-buffers/docs/reference/google.protobuf#empty)
    virtual ::grpc::Status UndeployConversationModel(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* request, ::google::longrunning::Operation* response);
    // Gets an evaluation of conversation model.
    virtual ::grpc::Status GetConversationModelEvaluation(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* request, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* response);
    // Lists evaluations of a conversation model.
    virtual ::grpc::Status ListConversationModelEvaluations(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* response);
    // Creates evaluation of a conversation model.
    virtual ::grpc::Status CreateConversationModelEvaluation(::grpc::ServerContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateConversationModel() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConversationModel(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::CreateConversationModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetConversationModel() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConversationModel(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::GetConversationModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::ConversationModel>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListConversationModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListConversationModels() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ListConversationModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModels(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConversationModels(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::ListConversationModelsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::ListConversationModelsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteConversationModel() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteConversationModel(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeployConversationModel() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeployConversationModel(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::DeployConversationModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UndeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UndeployConversationModel() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_UndeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeployConversationModel(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetConversationModelEvaluation() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_GetConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConversationModelEvaluation(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::ConversationModelEvaluation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListConversationModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListConversationModelEvaluations() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_ListConversationModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConversationModelEvaluations(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateConversationModelEvaluation() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_CreateConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConversationModelEvaluation(::grpc::ServerContext* context, ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateConversationModel<WithAsyncMethod_GetConversationModel<WithAsyncMethod_ListConversationModels<WithAsyncMethod_DeleteConversationModel<WithAsyncMethod_DeployConversationModel<WithAsyncMethod_UndeployConversationModel<WithAsyncMethod_GetConversationModelEvaluation<WithAsyncMethod_ListConversationModelEvaluations<WithAsyncMethod_CreateConversationModelEvaluation<Service > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateConversationModel() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::CreateConversationModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* request, ::google::longrunning::Operation* response) { return this->CreateConversationModel(context, request, response); }));}
    void SetMessageAllocatorFor_CreateConversationModel(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::CreateConversationModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::CreateConversationModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetConversationModel() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetConversationModelRequest, ::google::cloud::dialogflow::v2::ConversationModel>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* request, ::google::cloud::dialogflow::v2::ConversationModel* response) { return this->GetConversationModel(context, request, response); }));}
    void SetMessageAllocatorFor_GetConversationModel(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::GetConversationModelRequest, ::google::cloud::dialogflow::v2::ConversationModel>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetConversationModelRequest, ::google::cloud::dialogflow::v2::ConversationModel>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModel* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListConversationModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListConversationModels() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ListConversationModelsRequest, ::google::cloud::dialogflow::v2::ListConversationModelsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* response) { return this->ListConversationModels(context, request, response); }));}
    void SetMessageAllocatorFor_ListConversationModels(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::ListConversationModelsRequest, ::google::cloud::dialogflow::v2::ListConversationModelsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ListConversationModelsRequest, ::google::cloud::dialogflow::v2::ListConversationModelsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListConversationModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModels(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConversationModels(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteConversationModel() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::DeleteConversationModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* request, ::google::longrunning::Operation* response) { return this->DeleteConversationModel(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteConversationModel(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::DeleteConversationModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::DeleteConversationModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeployConversationModel() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::DeployConversationModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* request, ::google::longrunning::Operation* response) { return this->DeployConversationModel(context, request, response); }));}
    void SetMessageAllocatorFor_DeployConversationModel(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::DeployConversationModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::DeployConversationModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeployConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UndeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UndeployConversationModel() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::UndeployConversationModelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* request, ::google::longrunning::Operation* response) { return this->UndeployConversationModel(context, request, response); }));}
    void SetMessageAllocatorFor_UndeployConversationModel(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::UndeployConversationModelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::UndeployConversationModelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UndeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeployConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetConversationModelEvaluation() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest, ::google::cloud::dialogflow::v2::ConversationModelEvaluation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* request, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* response) { return this->GetConversationModelEvaluation(context, request, response); }));}
    void SetMessageAllocatorFor_GetConversationModelEvaluation(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest, ::google::cloud::dialogflow::v2::ConversationModelEvaluation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest, ::google::cloud::dialogflow::v2::ConversationModelEvaluation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConversationModelEvaluation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListConversationModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListConversationModelEvaluations() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* request, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* response) { return this->ListConversationModelEvaluations(context, request, response); }));}
    void SetMessageAllocatorFor_ListConversationModelEvaluations(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListConversationModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConversationModelEvaluations(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateConversationModelEvaluation() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* request, ::google::longrunning::Operation* response) { return this->CreateConversationModelEvaluation(context, request, response); }));}
    void SetMessageAllocatorFor_CreateConversationModelEvaluation(
        ::grpc::MessageAllocator< ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConversationModelEvaluation(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateConversationModel<WithCallbackMethod_GetConversationModel<WithCallbackMethod_ListConversationModels<WithCallbackMethod_DeleteConversationModel<WithCallbackMethod_DeployConversationModel<WithCallbackMethod_UndeployConversationModel<WithCallbackMethod_GetConversationModelEvaluation<WithCallbackMethod_ListConversationModelEvaluations<WithCallbackMethod_CreateConversationModelEvaluation<Service > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateConversationModel() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetConversationModel() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListConversationModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListConversationModels() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ListConversationModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModels(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteConversationModel() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeployConversationModel() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UndeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UndeployConversationModel() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_UndeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetConversationModelEvaluation() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_GetConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListConversationModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListConversationModelEvaluations() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_ListConversationModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateConversationModelEvaluation() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_CreateConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateConversationModel() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConversationModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetConversationModel() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConversationModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListConversationModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListConversationModels() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_ListConversationModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModels(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConversationModels(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteConversationModel() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteConversationModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeployConversationModel() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeployConversationModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UndeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UndeployConversationModel() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_UndeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUndeployConversationModel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetConversationModelEvaluation() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_GetConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetConversationModelEvaluation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListConversationModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListConversationModelEvaluations() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_ListConversationModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListConversationModelEvaluations(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateConversationModelEvaluation() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_CreateConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateConversationModelEvaluation(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateConversationModel() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateConversationModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetConversationModel() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetConversationModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListConversationModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListConversationModels() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListConversationModels(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListConversationModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModels(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConversationModels(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteConversationModel() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteConversationModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeployConversationModel() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeployConversationModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeployConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UndeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UndeployConversationModel() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UndeployConversationModel(context, request, response); }));
    }
    ~WithRawCallbackMethod_UndeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UndeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UndeployConversationModel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetConversationModelEvaluation() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetConversationModelEvaluation(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetConversationModelEvaluation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListConversationModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListConversationModelEvaluations() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListConversationModelEvaluations(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListConversationModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListConversationModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListConversationModelEvaluations(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateConversationModelEvaluation() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateConversationModelEvaluation(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateConversationModelEvaluation(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateConversationModel() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::CreateConversationModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::CreateConversationModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateConversationModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateConversationModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::CreateConversationModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetConversationModel() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::GetConversationModelRequest, ::google::cloud::dialogflow::v2::ConversationModel>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::GetConversationModelRequest, ::google::cloud::dialogflow::v2::ConversationModel>* streamer) {
                       return this->StreamedGetConversationModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetConversationModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::GetConversationModelRequest,::google::cloud::dialogflow::v2::ConversationModel>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListConversationModels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListConversationModels() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::ListConversationModelsRequest, ::google::cloud::dialogflow::v2::ListConversationModelsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::ListConversationModelsRequest, ::google::cloud::dialogflow::v2::ListConversationModelsResponse>* streamer) {
                       return this->StreamedListConversationModels(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListConversationModels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListConversationModels(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListConversationModels(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::ListConversationModelsRequest,::google::cloud::dialogflow::v2::ListConversationModelsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteConversationModel() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::DeleteConversationModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::DeleteConversationModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteConversationModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeleteConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteConversationModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::DeleteConversationModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeployConversationModel() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::DeployConversationModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::DeployConversationModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeployConversationModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::DeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeployConversationModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::DeployConversationModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UndeployConversationModel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UndeployConversationModel() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::UndeployConversationModelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::UndeployConversationModelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUndeployConversationModel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UndeployConversationModel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UndeployConversationModel(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::UndeployConversationModelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUndeployConversationModel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::UndeployConversationModelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetConversationModelEvaluation() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest, ::google::cloud::dialogflow::v2::ConversationModelEvaluation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest, ::google::cloud::dialogflow::v2::ConversationModelEvaluation>* streamer) {
                       return this->StreamedGetConversationModelEvaluation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest* /*request*/, ::google::cloud::dialogflow::v2::ConversationModelEvaluation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetConversationModelEvaluation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::GetConversationModelEvaluationRequest,::google::cloud::dialogflow::v2::ConversationModelEvaluation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListConversationModelEvaluations : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListConversationModelEvaluations() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>* streamer) {
                       return this->StreamedListConversationModelEvaluations(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListConversationModelEvaluations() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListConversationModelEvaluations(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest* /*request*/, ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListConversationModelEvaluations(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::ListConversationModelEvaluationsRequest,::google::cloud::dialogflow::v2::ListConversationModelEvaluationsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateConversationModelEvaluation : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateConversationModelEvaluation() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateConversationModelEvaluation(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateConversationModelEvaluation() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateConversationModelEvaluation(::grpc::ServerContext* /*context*/, const ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateConversationModelEvaluation(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::dialogflow::v2::CreateConversationModelEvaluationRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateConversationModel<WithStreamedUnaryMethod_GetConversationModel<WithStreamedUnaryMethod_ListConversationModels<WithStreamedUnaryMethod_DeleteConversationModel<WithStreamedUnaryMethod_DeployConversationModel<WithStreamedUnaryMethod_UndeployConversationModel<WithStreamedUnaryMethod_GetConversationModelEvaluation<WithStreamedUnaryMethod_ListConversationModelEvaluations<WithStreamedUnaryMethod_CreateConversationModelEvaluation<Service > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateConversationModel<WithStreamedUnaryMethod_GetConversationModel<WithStreamedUnaryMethod_ListConversationModels<WithStreamedUnaryMethod_DeleteConversationModel<WithStreamedUnaryMethod_DeployConversationModel<WithStreamedUnaryMethod_UndeployConversationModel<WithStreamedUnaryMethod_GetConversationModelEvaluation<WithStreamedUnaryMethod_ListConversationModelEvaluations<WithStreamedUnaryMethod_CreateConversationModelEvaluation<Service > > > > > > > > > StreamedService;
};

}  // namespace v2
}  // namespace dialogflow
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fdialogflow_2fv2_2fconversation_5fmodel_2eproto__INCLUDED
