// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/discoveryengine/v1/control_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_CONTROL_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_CONTROL_STUB_H

#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/discoveryengine/v1/control_service.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace discoveryengine_v1_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class ControlServiceStub {
 public:
  virtual ~ControlServiceStub() = 0;

  virtual StatusOr<google::cloud::discoveryengine::v1::Control> CreateControl(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::CreateControlRequest const&
          request) = 0;

  virtual Status DeleteControl(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::DeleteControlRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::discoveryengine::v1::Control> UpdateControl(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::UpdateControlRequest const&
          request) = 0;

  virtual StatusOr<google::cloud::discoveryengine::v1::Control> GetControl(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::GetControlRequest const& request) = 0;

  virtual StatusOr<google::cloud::discoveryengine::v1::ListControlsResponse>
  ListControls(grpc::ClientContext& context, Options const& options,
               google::cloud::discoveryengine::v1::ListControlsRequest const&
                   request) = 0;

  virtual StatusOr<google::longrunning::ListOperationsResponse> ListOperations(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::ListOperationsRequest const& request) = 0;

  virtual StatusOr<google::longrunning::Operation> GetOperation(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::GetOperationRequest const& request) = 0;

  virtual Status CancelOperation(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::CancelOperationRequest const& request) = 0;
};

class DefaultControlServiceStub : public ControlServiceStub {
 public:
  explicit DefaultControlServiceStub(
      std::unique_ptr<
          google::cloud::discoveryengine::v1::ControlService::StubInterface>
          grpc_stub,
      std::unique_ptr<google::longrunning::Operations::StubInterface>
          operations_stub)
      : grpc_stub_(std::move(grpc_stub)),
        operations_stub_(std::move(operations_stub)) {}

  StatusOr<google::cloud::discoveryengine::v1::Control> CreateControl(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::CreateControlRequest const& request)
      override;

  Status DeleteControl(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::DeleteControlRequest const& request)
      override;

  StatusOr<google::cloud::discoveryengine::v1::Control> UpdateControl(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::UpdateControlRequest const& request)
      override;

  StatusOr<google::cloud::discoveryengine::v1::Control> GetControl(
      grpc::ClientContext& context, Options const& options,
      google::cloud::discoveryengine::v1::GetControlRequest const& request)
      override;

  StatusOr<google::cloud::discoveryengine::v1::ListControlsResponse>
  ListControls(grpc::ClientContext& context, Options const& options,
               google::cloud::discoveryengine::v1::ListControlsRequest const&
                   request) override;

  StatusOr<google::longrunning::ListOperationsResponse> ListOperations(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::ListOperationsRequest const& request) override;

  StatusOr<google::longrunning::Operation> GetOperation(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::GetOperationRequest const& request) override;

  Status CancelOperation(
      grpc::ClientContext& context, Options const& options,
      google::longrunning::CancelOperationRequest const& request) override;

 private:
  std::unique_ptr<
      google::cloud::discoveryengine::v1::ControlService::StubInterface>
      grpc_stub_;
  std::unique_ptr<google::longrunning::Operations::StubInterface>
      operations_stub_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace discoveryengine_v1_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_DISCOVERYENGINE_V1_INTERNAL_CONTROL_STUB_H
