// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/monitoring/v3/metric_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MONITORING_V3_MOCKS_MOCK_METRIC_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MONITORING_V3_MOCKS_MOCK_METRIC_CONNECTION_H

#include "google/cloud/monitoring/v3/metric_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace monitoring_v3_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `MetricServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `MetricServiceClient`. To do so,
 * construct an object of type `MetricServiceClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockMetricServiceConnection
    : public monitoring_v3::MetricServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      (StreamRange<google::api::MonitoredResourceDescriptor>),
      ListMonitoredResourceDescriptors,
      (google::monitoring::v3::ListMonitoredResourceDescriptorsRequest request),
      (override));

  MOCK_METHOD(
      StatusOr<google::api::MonitoredResourceDescriptor>,
      GetMonitoredResourceDescriptor,
      (google::monitoring::v3::GetMonitoredResourceDescriptorRequest const&
           request),
      (override));

  MOCK_METHOD((StreamRange<google::api::MetricDescriptor>),
              ListMetricDescriptors,
              (google::monitoring::v3::ListMetricDescriptorsRequest request),
              (override));

  MOCK_METHOD(
      StatusOr<google::api::MetricDescriptor>, GetMetricDescriptor,
      (google::monitoring::v3::GetMetricDescriptorRequest const& request),
      (override));

  MOCK_METHOD(
      StatusOr<google::api::MetricDescriptor>, CreateMetricDescriptor,
      (google::monitoring::v3::CreateMetricDescriptorRequest const& request),
      (override));

  MOCK_METHOD(
      Status, DeleteMetricDescriptor,
      (google::monitoring::v3::DeleteMetricDescriptorRequest const& request),
      (override));

  MOCK_METHOD((StreamRange<google::monitoring::v3::TimeSeries>), ListTimeSeries,
              (google::monitoring::v3::ListTimeSeriesRequest request),
              (override));

  MOCK_METHOD(Status, CreateTimeSeries,
              (google::monitoring::v3::CreateTimeSeriesRequest const& request),
              (override));

  MOCK_METHOD(Status, CreateServiceTimeSeries,
              (google::monitoring::v3::CreateTimeSeriesRequest const& request),
              (override));

  MOCK_METHOD(future<Status>, AsyncCreateTimeSeries,
              (google::monitoring::v3::CreateTimeSeriesRequest const& request),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace monitoring_v3_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_MONITORING_V3_MOCKS_MOCK_METRIC_CONNECTION_H
