// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/networkmanagement/v1/vpc_flow_logs.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fnetworkmanagement_2fv1_2fvpc_5fflow_5flogs_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fnetworkmanagement_2fv1_2fvpc_5fflow_5flogs_2eproto__INCLUDED

#include "google/cloud/networkmanagement/v1/vpc_flow_logs.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace networkmanagement {
namespace v1 {

// The VPC Flow Logs service in the Google Cloud Network Management API provides
// configurations that generate Flow Logs. The service and the configuration
// resources created using this service are global.
class VpcFlowLogsService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.networkmanagement.v1.VpcFlowLogsService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists all `VpcFlowLogsConfigs` in a given project.
    virtual ::grpc::Status ListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>> AsyncListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>>(AsyncListVpcFlowLogsConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>> PrepareAsyncListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>>(PrepareAsyncListVpcFlowLogsConfigsRaw(context, request, cq));
    }
    // Gets the details of a specific `VpcFlowLogsConfig`.
    virtual ::grpc::Status GetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>> AsyncGetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>>(AsyncGetVpcFlowLogsConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>> PrepareAsyncGetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>>(PrepareAsyncGetVpcFlowLogsConfigRaw(context, request, cq));
    }
    // Creates a new `VpcFlowLogsConfig`.
    // If a configuration with the exact same settings already exists (even if the
    // ID is different), the creation fails.
    // Notes:
    //
    //   1. Creating a configuration with state=DISABLED will fail
    //   2. The following fields are not considered as `settings` for the purpose
    //   of the check mentioned above, therefore - creating another configuration
    //   with the same fields but different values for the following fields will
    //   fail as well:
    //       * name
    //       * create_time
    //       * update_time
    //       * labels
    //       * description
    virtual ::grpc::Status CreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateVpcFlowLogsConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateVpcFlowLogsConfigRaw(context, request, cq));
    }
    // Updates an existing `VpcFlowLogsConfig`.
    // If a configuration with the exact same settings already exists (even if the
    // ID is different), the creation fails.
    // Notes:
    //
    //   1. Updating a configuration with state=DISABLED will fail.
    //   2. The following fields are not considered as `settings` for the purpose
    //   of the check mentioned above, therefore - updating another configuration
    //   with the same fields but different values for the following fields will
    //   fail as well:
    //       * name
    //       * create_time
    //       * update_time
    //       * labels
    //       * description
    virtual ::grpc::Status UpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateVpcFlowLogsConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateVpcFlowLogsConfigRaw(context, request, cq));
    }
    // Deletes a specific `VpcFlowLogsConfig`.
    virtual ::grpc::Status DeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteVpcFlowLogsConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteVpcFlowLogsConfigRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists all `VpcFlowLogsConfigs` in a given project.
      virtual void ListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* request, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* request, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets the details of a specific `VpcFlowLogsConfig`.
      virtual void GetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* request, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* request, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new `VpcFlowLogsConfig`.
      // If a configuration with the exact same settings already exists (even if the
      // ID is different), the creation fails.
      // Notes:
      //
      //   1. Creating a configuration with state=DISABLED will fail
      //   2. The following fields are not considered as `settings` for the purpose
      //   of the check mentioned above, therefore - creating another configuration
      //   with the same fields but different values for the following fields will
      //   fail as well:
      //       * name
      //       * create_time
      //       * update_time
      //       * labels
      //       * description
      virtual void CreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing `VpcFlowLogsConfig`.
      // If a configuration with the exact same settings already exists (even if the
      // ID is different), the creation fails.
      // Notes:
      //
      //   1. Updating a configuration with state=DISABLED will fail.
      //   2. The following fields are not considered as `settings` for the purpose
      //   of the check mentioned above, therefore - updating another configuration
      //   with the same fields but different values for the following fields will
      //   fail as well:
      //       * name
      //       * create_time
      //       * update_time
      //       * labels
      //       * description
      virtual void UpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a specific `VpcFlowLogsConfig`.
      virtual void DeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>* AsyncListVpcFlowLogsConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>* PrepareAsyncListVpcFlowLogsConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>* AsyncGetVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>* PrepareAsyncGetVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>> AsyncListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>>(AsyncListVpcFlowLogsConfigsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>> PrepareAsyncListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>>(PrepareAsyncListVpcFlowLogsConfigsRaw(context, request, cq));
    }
    ::grpc::Status GetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>> AsyncGetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>>(AsyncGetVpcFlowLogsConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>> PrepareAsyncGetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>>(PrepareAsyncGetVpcFlowLogsConfigRaw(context, request, cq));
    }
    ::grpc::Status CreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateVpcFlowLogsConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateVpcFlowLogsConfigRaw(context, request, cq));
    }
    ::grpc::Status UpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateVpcFlowLogsConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateVpcFlowLogsConfigRaw(context, request, cq));
    }
    ::grpc::Status DeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteVpcFlowLogsConfigRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteVpcFlowLogsConfigRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* request, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListVpcFlowLogsConfigs(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* request, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* request, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* response, std::function<void(::grpc::Status)>) override;
      void GetVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* request, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteVpcFlowLogsConfig(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>* AsyncListVpcFlowLogsConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>* PrepareAsyncListVpcFlowLogsConfigsRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>* AsyncGetVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>* PrepareAsyncGetVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteVpcFlowLogsConfigRaw(::grpc::ClientContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListVpcFlowLogsConfigs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetVpcFlowLogsConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateVpcFlowLogsConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateVpcFlowLogsConfig_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteVpcFlowLogsConfig_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists all `VpcFlowLogsConfigs` in a given project.
    virtual ::grpc::Status ListVpcFlowLogsConfigs(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* request, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* response);
    // Gets the details of a specific `VpcFlowLogsConfig`.
    virtual ::grpc::Status GetVpcFlowLogsConfig(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* request, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* response);
    // Creates a new `VpcFlowLogsConfig`.
    // If a configuration with the exact same settings already exists (even if the
    // ID is different), the creation fails.
    // Notes:
    //
    //   1. Creating a configuration with state=DISABLED will fail
    //   2. The following fields are not considered as `settings` for the purpose
    //   of the check mentioned above, therefore - creating another configuration
    //   with the same fields but different values for the following fields will
    //   fail as well:
    //       * name
    //       * create_time
    //       * update_time
    //       * labels
    //       * description
    virtual ::grpc::Status CreateVpcFlowLogsConfig(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response);
    // Updates an existing `VpcFlowLogsConfig`.
    // If a configuration with the exact same settings already exists (even if the
    // ID is different), the creation fails.
    // Notes:
    //
    //   1. Updating a configuration with state=DISABLED will fail.
    //   2. The following fields are not considered as `settings` for the purpose
    //   of the check mentioned above, therefore - updating another configuration
    //   with the same fields but different values for the following fields will
    //   fail as well:
    //       * name
    //       * create_time
    //       * update_time
    //       * labels
    //       * description
    virtual ::grpc::Status UpdateVpcFlowLogsConfig(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response);
    // Deletes a specific `VpcFlowLogsConfig`.
    virtual ::grpc::Status DeleteVpcFlowLogsConfig(::grpc::ServerContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListVpcFlowLogsConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListVpcFlowLogsConfigs() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListVpcFlowLogsConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVpcFlowLogsConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVpcFlowLogsConfigs(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* /*request*/, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVpcFlowLogsConfig(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVpcFlowLogsConfig(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVpcFlowLogsConfig(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVpcFlowLogsConfig(::grpc::ServerContext* context, ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListVpcFlowLogsConfigs<WithAsyncMethod_GetVpcFlowLogsConfig<WithAsyncMethod_CreateVpcFlowLogsConfig<WithAsyncMethod_UpdateVpcFlowLogsConfig<WithAsyncMethod_DeleteVpcFlowLogsConfig<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListVpcFlowLogsConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListVpcFlowLogsConfigs() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* request, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* response) { return this->ListVpcFlowLogsConfigs(context, request, response); }));}
    void SetMessageAllocatorFor_ListVpcFlowLogsConfigs(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListVpcFlowLogsConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVpcFlowLogsConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVpcFlowLogsConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* request, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* response) { return this->GetVpcFlowLogsConfig(context, request, response); }));}
    void SetMessageAllocatorFor_GetVpcFlowLogsConfig(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* /*request*/, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVpcFlowLogsConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* /*request*/, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response) { return this->CreateVpcFlowLogsConfig(context, request, response); }));}
    void SetMessageAllocatorFor_CreateVpcFlowLogsConfig(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVpcFlowLogsConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response) { return this->UpdateVpcFlowLogsConfig(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateVpcFlowLogsConfig(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVpcFlowLogsConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* request, ::google::longrunning::Operation* response) { return this->DeleteVpcFlowLogsConfig(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteVpcFlowLogsConfig(
        ::grpc::MessageAllocator< ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVpcFlowLogsConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListVpcFlowLogsConfigs<WithCallbackMethod_GetVpcFlowLogsConfig<WithCallbackMethod_CreateVpcFlowLogsConfig<WithCallbackMethod_UpdateVpcFlowLogsConfig<WithCallbackMethod_DeleteVpcFlowLogsConfig<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListVpcFlowLogsConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListVpcFlowLogsConfigs() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListVpcFlowLogsConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVpcFlowLogsConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* /*request*/, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListVpcFlowLogsConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListVpcFlowLogsConfigs() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListVpcFlowLogsConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVpcFlowLogsConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListVpcFlowLogsConfigs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* /*request*/, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetVpcFlowLogsConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateVpcFlowLogsConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateVpcFlowLogsConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteVpcFlowLogsConfig(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListVpcFlowLogsConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListVpcFlowLogsConfigs() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListVpcFlowLogsConfigs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListVpcFlowLogsConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListVpcFlowLogsConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListVpcFlowLogsConfigs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetVpcFlowLogsConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* /*request*/, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetVpcFlowLogsConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateVpcFlowLogsConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateVpcFlowLogsConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateVpcFlowLogsConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateVpcFlowLogsConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteVpcFlowLogsConfig(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteVpcFlowLogsConfig(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListVpcFlowLogsConfigs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListVpcFlowLogsConfigs() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>* streamer) {
                       return this->StreamedListVpcFlowLogsConfigs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListVpcFlowLogsConfigs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListVpcFlowLogsConfigs(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest* /*request*/, ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListVpcFlowLogsConfigs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsRequest,::google::cloud::networkmanagement::v1::ListVpcFlowLogsConfigsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>* streamer) {
                       return this->StreamedGetVpcFlowLogsConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest* /*request*/, ::google::cloud::networkmanagement::v1::VpcFlowLogsConfig* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetVpcFlowLogsConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::GetVpcFlowLogsConfigRequest,::google::cloud::networkmanagement::v1::VpcFlowLogsConfig>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateVpcFlowLogsConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateVpcFlowLogsConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::CreateVpcFlowLogsConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateVpcFlowLogsConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateVpcFlowLogsConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::UpdateVpcFlowLogsConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteVpcFlowLogsConfig : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteVpcFlowLogsConfig() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteVpcFlowLogsConfig(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteVpcFlowLogsConfig() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteVpcFlowLogsConfig(::grpc::ServerContext* /*context*/, const ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteVpcFlowLogsConfig(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::networkmanagement::v1::DeleteVpcFlowLogsConfigRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListVpcFlowLogsConfigs<WithStreamedUnaryMethod_GetVpcFlowLogsConfig<WithStreamedUnaryMethod_CreateVpcFlowLogsConfig<WithStreamedUnaryMethod_UpdateVpcFlowLogsConfig<WithStreamedUnaryMethod_DeleteVpcFlowLogsConfig<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListVpcFlowLogsConfigs<WithStreamedUnaryMethod_GetVpcFlowLogsConfig<WithStreamedUnaryMethod_CreateVpcFlowLogsConfig<WithStreamedUnaryMethod_UpdateVpcFlowLogsConfig<WithStreamedUnaryMethod_DeleteVpcFlowLogsConfig<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace networkmanagement
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fnetworkmanagement_2fv1_2fvpc_5fflow_5flogs_2eproto__INCLUDED
