// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/retail/v2/user_event_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fretail_2fv2_2fuser_5fevent_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fretail_2fv2_2fuser_5fevent_5fservice_2eproto__INCLUDED

#include "google/cloud/retail/v2/user_event_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace retail {
namespace v2 {

// Service for ingesting end user actions on the customer website.
class UserEventService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.retail.v2.UserEventService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Writes a single user event.
    virtual ::grpc::Status WriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::google::cloud::retail::v2::UserEvent* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::UserEvent>> AsyncWriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::UserEvent>>(AsyncWriteUserEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::UserEvent>> PrepareAsyncWriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::UserEvent>>(PrepareAsyncWriteUserEventRaw(context, request, cq));
    }
    // Writes a single user event from the browser. This uses a GET request to
    // due to browser restriction of POST-ing to a 3rd party domain.
    //
    // This method is used only by the Retail API JavaScript pixel and Google Tag
    // Manager. Users should not call this method directly.
    virtual ::grpc::Status CollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::google::api::HttpBody* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>> AsyncCollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>>(AsyncCollectUserEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>> PrepareAsyncCollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>>(PrepareAsyncCollectUserEventRaw(context, request, cq));
    }
    // Deletes permanently all user events specified by the filter provided.
    // Depending on the number of events specified by the filter, this operation
    // could take hours or days to complete. To test a filter, use the list
    // command first.
    virtual ::grpc::Status PurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncPurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncPurgeUserEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncPurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncPurgeUserEventsRaw(context, request, cq));
    }
    // Bulk import of User events. Request processing might be
    // synchronous. Events that already exist are skipped.
    // Use this method for backfilling historical user events.
    //
    // `Operation.response` is of type `ImportResponse`. Note that it is
    // possible for a subset of the items to be successfully inserted.
    // `Operation.metadata` is of type `ImportMetadata`.
    virtual ::grpc::Status ImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncImportUserEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncImportUserEventsRaw(context, request, cq));
    }
    // Starts a user-event rejoin operation with latest product catalog. Events
    // are not annotated with detailed product information for products that are
    // missing from the catalog when the user event is ingested. These
    // events are stored as unjoined events with limited usage on training and
    // serving. You can use this method to start a join operation on specified
    // events with the latest version of product catalog. You can also use this
    // method to correct events joined with the wrong product catalog. A rejoin
    // operation can take hours or days to complete.
    virtual ::grpc::Status RejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncRejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncRejoinUserEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncRejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncRejoinUserEventsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Writes a single user event.
      virtual void WriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest* request, ::google::cloud::retail::v2::UserEvent* response, std::function<void(::grpc::Status)>) = 0;
      virtual void WriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest* request, ::google::cloud::retail::v2::UserEvent* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Writes a single user event from the browser. This uses a GET request to
      // due to browser restriction of POST-ing to a 3rd party domain.
      //
      // This method is used only by the Retail API JavaScript pixel and Google Tag
      // Manager. Users should not call this method directly.
      virtual void CollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest* request, ::google::api::HttpBody* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest* request, ::google::api::HttpBody* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes permanently all user events specified by the filter provided.
      // Depending on the number of events specified by the filter, this operation
      // could take hours or days to complete. To test a filter, use the list
      // command first.
      virtual void PurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Bulk import of User events. Request processing might be
      // synchronous. Events that already exist are skipped.
      // Use this method for backfilling historical user events.
      //
      // `Operation.response` is of type `ImportResponse`. Note that it is
      // possible for a subset of the items to be successfully inserted.
      // `Operation.metadata` is of type `ImportMetadata`.
      virtual void ImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts a user-event rejoin operation with latest product catalog. Events
      // are not annotated with detailed product information for products that are
      // missing from the catalog when the user event is ingested. These
      // events are stored as unjoined events with limited usage on training and
      // serving. You can use this method to start a join operation on specified
      // events with the latest version of product catalog. You can also use this
      // method to correct events joined with the wrong product catalog. A rejoin
      // operation can take hours or days to complete.
      virtual void RejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::UserEvent>* AsyncWriteUserEventRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::retail::v2::UserEvent>* PrepareAsyncWriteUserEventRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>* AsyncCollectUserEventRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::api::HttpBody>* PrepareAsyncCollectUserEventRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncPurgeUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncPurgeUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncImportUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncImportUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncRejoinUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncRejoinUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status WriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::google::cloud::retail::v2::UserEvent* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::UserEvent>> AsyncWriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::UserEvent>>(AsyncWriteUserEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::UserEvent>> PrepareAsyncWriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::UserEvent>>(PrepareAsyncWriteUserEventRaw(context, request, cq));
    }
    ::grpc::Status CollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::google::api::HttpBody* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>> AsyncCollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>>(AsyncCollectUserEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>> PrepareAsyncCollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>>(PrepareAsyncCollectUserEventRaw(context, request, cq));
    }
    ::grpc::Status PurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncPurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncPurgeUserEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncPurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncPurgeUserEventsRaw(context, request, cq));
    }
    ::grpc::Status ImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncImportUserEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncImportUserEventsRaw(context, request, cq));
    }
    ::grpc::Status RejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncRejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncRejoinUserEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncRejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncRejoinUserEventsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void WriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest* request, ::google::cloud::retail::v2::UserEvent* response, std::function<void(::grpc::Status)>) override;
      void WriteUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest* request, ::google::cloud::retail::v2::UserEvent* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest* request, ::google::api::HttpBody* response, std::function<void(::grpc::Status)>) override;
      void CollectUserEvent(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest* request, ::google::api::HttpBody* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void PurgeUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void RejoinUserEvents(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::UserEvent>* AsyncWriteUserEventRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::retail::v2::UserEvent>* PrepareAsyncWriteUserEventRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>* AsyncCollectUserEventRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::api::HttpBody>* PrepareAsyncCollectUserEventRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncPurgeUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncPurgeUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncImportUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncImportUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncRejoinUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncRejoinUserEventsRaw(::grpc::ClientContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_WriteUserEvent_;
    const ::grpc::internal::RpcMethod rpcmethod_CollectUserEvent_;
    const ::grpc::internal::RpcMethod rpcmethod_PurgeUserEvents_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportUserEvents_;
    const ::grpc::internal::RpcMethod rpcmethod_RejoinUserEvents_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Writes a single user event.
    virtual ::grpc::Status WriteUserEvent(::grpc::ServerContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest* request, ::google::cloud::retail::v2::UserEvent* response);
    // Writes a single user event from the browser. This uses a GET request to
    // due to browser restriction of POST-ing to a 3rd party domain.
    //
    // This method is used only by the Retail API JavaScript pixel and Google Tag
    // Manager. Users should not call this method directly.
    virtual ::grpc::Status CollectUserEvent(::grpc::ServerContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest* request, ::google::api::HttpBody* response);
    // Deletes permanently all user events specified by the filter provided.
    // Depending on the number of events specified by the filter, this operation
    // could take hours or days to complete. To test a filter, use the list
    // command first.
    virtual ::grpc::Status PurgeUserEvents(::grpc::ServerContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest* request, ::google::longrunning::Operation* response);
    // Bulk import of User events. Request processing might be
    // synchronous. Events that already exist are skipped.
    // Use this method for backfilling historical user events.
    //
    // `Operation.response` is of type `ImportResponse`. Note that it is
    // possible for a subset of the items to be successfully inserted.
    // `Operation.metadata` is of type `ImportMetadata`.
    virtual ::grpc::Status ImportUserEvents(::grpc::ServerContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest* request, ::google::longrunning::Operation* response);
    // Starts a user-event rejoin operation with latest product catalog. Events
    // are not annotated with detailed product information for products that are
    // missing from the catalog when the user event is ingested. These
    // events are stored as unjoined events with limited usage on training and
    // serving. You can use this method to start a join operation on specified
    // events with the latest version of product catalog. You can also use this
    // method to correct events joined with the wrong product catalog. A rejoin
    // operation can take hours or days to complete.
    virtual ::grpc::Status RejoinUserEvents(::grpc::ServerContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_WriteUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_WriteUserEvent() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_WriteUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::WriteUserEventRequest* /*request*/, ::google::cloud::retail::v2::UserEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestWriteUserEvent(::grpc::ServerContext* context, ::google::cloud::retail::v2::WriteUserEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::retail::v2::UserEvent>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CollectUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CollectUserEvent() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_CollectUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CollectUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CollectUserEventRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCollectUserEvent(::grpc::ServerContext* context, ::google::cloud::retail::v2::CollectUserEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::api::HttpBody>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PurgeUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PurgeUserEvents() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_PurgeUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PurgeUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPurgeUserEvents(::grpc::ServerContext* context, ::google::cloud::retail::v2::PurgeUserEventsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportUserEvents() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_ImportUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportUserEvents(::grpc::ServerContext* context, ::google::cloud::retail::v2::ImportUserEventsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RejoinUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RejoinUserEvents() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_RejoinUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejoinUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RejoinUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRejoinUserEvents(::grpc::ServerContext* context, ::google::cloud::retail::v2::RejoinUserEventsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_WriteUserEvent<WithAsyncMethod_CollectUserEvent<WithAsyncMethod_PurgeUserEvents<WithAsyncMethod_ImportUserEvents<WithAsyncMethod_RejoinUserEvents<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_WriteUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_WriteUserEvent() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::WriteUserEventRequest, ::google::cloud::retail::v2::UserEvent>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::WriteUserEventRequest* request, ::google::cloud::retail::v2::UserEvent* response) { return this->WriteUserEvent(context, request, response); }));}
    void SetMessageAllocatorFor_WriteUserEvent(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::WriteUserEventRequest, ::google::cloud::retail::v2::UserEvent>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::WriteUserEventRequest, ::google::cloud::retail::v2::UserEvent>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_WriteUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::WriteUserEventRequest* /*request*/, ::google::cloud::retail::v2::UserEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* WriteUserEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::WriteUserEventRequest* /*request*/, ::google::cloud::retail::v2::UserEvent* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CollectUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CollectUserEvent() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::CollectUserEventRequest, ::google::api::HttpBody>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::CollectUserEventRequest* request, ::google::api::HttpBody* response) { return this->CollectUserEvent(context, request, response); }));}
    void SetMessageAllocatorFor_CollectUserEvent(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::CollectUserEventRequest, ::google::api::HttpBody>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::CollectUserEventRequest, ::google::api::HttpBody>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CollectUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CollectUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CollectUserEventRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CollectUserEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::CollectUserEventRequest* /*request*/, ::google::api::HttpBody* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PurgeUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PurgeUserEvents() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::PurgeUserEventsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::PurgeUserEventsRequest* request, ::google::longrunning::Operation* response) { return this->PurgeUserEvents(context, request, response); }));}
    void SetMessageAllocatorFor_PurgeUserEvents(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::PurgeUserEventsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::PurgeUserEventsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PurgeUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PurgeUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PurgeUserEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::PurgeUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportUserEvents() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ImportUserEventsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::ImportUserEventsRequest* request, ::google::longrunning::Operation* response) { return this->ImportUserEvents(context, request, response); }));}
    void SetMessageAllocatorFor_ImportUserEvents(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::ImportUserEventsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::ImportUserEventsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportUserEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::ImportUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RejoinUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RejoinUserEvents() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::RejoinUserEventsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::retail::v2::RejoinUserEventsRequest* request, ::google::longrunning::Operation* response) { return this->RejoinUserEvents(context, request, response); }));}
    void SetMessageAllocatorFor_RejoinUserEvents(
        ::grpc::MessageAllocator< ::google::cloud::retail::v2::RejoinUserEventsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::retail::v2::RejoinUserEventsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RejoinUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejoinUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RejoinUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RejoinUserEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::retail::v2::RejoinUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_WriteUserEvent<WithCallbackMethod_CollectUserEvent<WithCallbackMethod_PurgeUserEvents<WithCallbackMethod_ImportUserEvents<WithCallbackMethod_RejoinUserEvents<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_WriteUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_WriteUserEvent() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_WriteUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::WriteUserEventRequest* /*request*/, ::google::cloud::retail::v2::UserEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CollectUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CollectUserEvent() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_CollectUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CollectUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CollectUserEventRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PurgeUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PurgeUserEvents() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_PurgeUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PurgeUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportUserEvents() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_ImportUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RejoinUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RejoinUserEvents() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_RejoinUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejoinUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RejoinUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_WriteUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_WriteUserEvent() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_WriteUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::WriteUserEventRequest* /*request*/, ::google::cloud::retail::v2::UserEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestWriteUserEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CollectUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CollectUserEvent() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_CollectUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CollectUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CollectUserEventRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCollectUserEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PurgeUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PurgeUserEvents() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_PurgeUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PurgeUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPurgeUserEvents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportUserEvents() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_ImportUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportUserEvents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RejoinUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RejoinUserEvents() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_RejoinUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejoinUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RejoinUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRejoinUserEvents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_WriteUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_WriteUserEvent() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->WriteUserEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_WriteUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status WriteUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::WriteUserEventRequest* /*request*/, ::google::cloud::retail::v2::UserEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* WriteUserEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CollectUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CollectUserEvent() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CollectUserEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_CollectUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CollectUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CollectUserEventRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CollectUserEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PurgeUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PurgeUserEvents() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PurgeUserEvents(context, request, response); }));
    }
    ~WithRawCallbackMethod_PurgeUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PurgeUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PurgeUserEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportUserEvents() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportUserEvents(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportUserEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RejoinUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RejoinUserEvents() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RejoinUserEvents(context, request, response); }));
    }
    ~WithRawCallbackMethod_RejoinUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RejoinUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RejoinUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RejoinUserEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_WriteUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_WriteUserEvent() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::WriteUserEventRequest, ::google::cloud::retail::v2::UserEvent>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::WriteUserEventRequest, ::google::cloud::retail::v2::UserEvent>* streamer) {
                       return this->StreamedWriteUserEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_WriteUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status WriteUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::WriteUserEventRequest* /*request*/, ::google::cloud::retail::v2::UserEvent* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedWriteUserEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::WriteUserEventRequest,::google::cloud::retail::v2::UserEvent>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CollectUserEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CollectUserEvent() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::CollectUserEventRequest, ::google::api::HttpBody>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::CollectUserEventRequest, ::google::api::HttpBody>* streamer) {
                       return this->StreamedCollectUserEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CollectUserEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CollectUserEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::CollectUserEventRequest* /*request*/, ::google::api::HttpBody* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCollectUserEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::CollectUserEventRequest,::google::api::HttpBody>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PurgeUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PurgeUserEvents() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::PurgeUserEventsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::PurgeUserEventsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedPurgeUserEvents(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PurgeUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PurgeUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::PurgeUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPurgeUserEvents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::PurgeUserEventsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportUserEvents() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::ImportUserEventsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::ImportUserEventsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedImportUserEvents(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::ImportUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportUserEvents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::ImportUserEventsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RejoinUserEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RejoinUserEvents() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::retail::v2::RejoinUserEventsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::retail::v2::RejoinUserEventsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedRejoinUserEvents(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RejoinUserEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RejoinUserEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::retail::v2::RejoinUserEventsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRejoinUserEvents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::retail::v2::RejoinUserEventsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_WriteUserEvent<WithStreamedUnaryMethod_CollectUserEvent<WithStreamedUnaryMethod_PurgeUserEvents<WithStreamedUnaryMethod_ImportUserEvents<WithStreamedUnaryMethod_RejoinUserEvents<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_WriteUserEvent<WithStreamedUnaryMethod_CollectUserEvent<WithStreamedUnaryMethod_PurgeUserEvents<WithStreamedUnaryMethod_ImportUserEvents<WithStreamedUnaryMethod_RejoinUserEvents<Service > > > > > StreamedService;
};

}  // namespace v2
}  // namespace retail
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fretail_2fv2_2fuser_5fevent_5fservice_2eproto__INCLUDED
