// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/vision/v1/product_search_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fvision_2fv1_2fproduct_5fsearch_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fvision_2fv1_2fproduct_5fsearch_5fservice_2eproto__INCLUDED

#include "google/cloud/vision/v1/product_search_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace vision {
namespace v1 {

// Manages Products and ProductSets of reference images for use in product
// search. It uses the following resource model:
//
// - The API has a collection of [ProductSet][google.cloud.vision.v1.ProductSet]
// resources, named `projects/*/locations/*/productSets/*`, which acts as a way
// to put different products into groups to limit identification.
//
// In parallel,
//
// - The API has a collection of [Product][google.cloud.vision.v1.Product]
// resources, named
//   `projects/*/locations/*/products/*`
//
// - Each [Product][google.cloud.vision.v1.Product] has a collection of
// [ReferenceImage][google.cloud.vision.v1.ReferenceImage] resources, named
//   `projects/*/locations/*/products/*/referenceImages/*`
class ProductSearch final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.vision.v1.ProductSearch";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates and returns a new ProductSet resource.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if display_name is missing, or is longer than
    //   4096 characters.
    virtual ::grpc::Status CreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::google::cloud::vision::v1::ProductSet* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>> AsyncCreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>>(AsyncCreateProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>> PrepareAsyncCreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>>(PrepareAsyncCreateProductSetRaw(context, request, cq));
    }
    // Lists ProductSets in an unspecified order.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if page_size is greater than 100, or less
    //   than 1.
    virtual ::grpc::Status ListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::google::cloud::vision::v1::ListProductSetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductSetsResponse>> AsyncListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductSetsResponse>>(AsyncListProductSetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductSetsResponse>> PrepareAsyncListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductSetsResponse>>(PrepareAsyncListProductSetsRaw(context, request, cq));
    }
    // Gets information associated with a ProductSet.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the ProductSet does not exist.
    virtual ::grpc::Status GetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::google::cloud::vision::v1::ProductSet* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>> AsyncGetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>>(AsyncGetProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>> PrepareAsyncGetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>>(PrepareAsyncGetProductSetRaw(context, request, cq));
    }
    // Makes changes to a ProductSet resource.
    // Only display_name can be updated currently.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the ProductSet does not exist.
    // * Returns INVALID_ARGUMENT if display_name is present in update_mask but
    //   missing from the request or longer than 4096 characters.
    virtual ::grpc::Status UpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::google::cloud::vision::v1::ProductSet* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>> AsyncUpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>>(AsyncUpdateProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>> PrepareAsyncUpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>>(PrepareAsyncUpdateProductSetRaw(context, request, cq));
    }
    // Permanently deletes a ProductSet. Products and ReferenceImages in the
    // ProductSet are not deleted.
    //
    // The actual image files are not deleted from Google Cloud Storage.
    virtual ::grpc::Status DeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteProductSetRaw(context, request, cq));
    }
    // Creates and returns a new product resource.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if display_name is missing or longer than 4096
    //   characters.
    // * Returns INVALID_ARGUMENT if description is longer than 4096 characters.
    // * Returns INVALID_ARGUMENT if product_category is missing or invalid.
    virtual ::grpc::Status CreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::google::cloud::vision::v1::Product* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>> AsyncCreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>>(AsyncCreateProductRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>> PrepareAsyncCreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>>(PrepareAsyncCreateProductRaw(context, request, cq));
    }
    // Lists products in an unspecified order.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if page_size is greater than 100 or less than 1.
    virtual ::grpc::Status ListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::google::cloud::vision::v1::ListProductsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsResponse>> AsyncListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsResponse>>(AsyncListProductsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsResponse>> PrepareAsyncListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsResponse>>(PrepareAsyncListProductsRaw(context, request, cq));
    }
    // Gets information associated with a Product.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the Product does not exist.
    virtual ::grpc::Status GetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::google::cloud::vision::v1::Product* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>> AsyncGetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>>(AsyncGetProductRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>> PrepareAsyncGetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>>(PrepareAsyncGetProductRaw(context, request, cq));
    }
    // Makes changes to a Product resource.
    // Only the `display_name`, `description`, and `labels` fields can be updated
    // right now.
    //
    // If labels are updated, the change will not be reflected in queries until
    // the next index time.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the Product does not exist.
    // * Returns INVALID_ARGUMENT if display_name is present in update_mask but is
    //   missing from the request or longer than 4096 characters.
    // * Returns INVALID_ARGUMENT if description is present in update_mask but is
    //   longer than 4096 characters.
    // * Returns INVALID_ARGUMENT if product_category is present in update_mask.
    virtual ::grpc::Status UpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::google::cloud::vision::v1::Product* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>> AsyncUpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>>(AsyncUpdateProductRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>> PrepareAsyncUpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>>(PrepareAsyncUpdateProductRaw(context, request, cq));
    }
    // Permanently deletes a product and its reference images.
    //
    // Metadata of the product and all its images will be deleted right away, but
    // search queries against ProductSets containing the product may still work
    // until all related caches are refreshed.
    virtual ::grpc::Status DeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteProductRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteProductRaw(context, request, cq));
    }
    // Creates and returns a new ReferenceImage resource.
    //
    // The `bounding_poly` field is optional. If `bounding_poly` is not specified,
    // the system will try to detect regions of interest in the image that are
    // compatible with the product_category on the parent product. If it is
    // specified, detection is ALWAYS skipped. The system converts polygons into
    // non-rotated rectangles.
    //
    // Note that the pipeline will resize the image if the image resolution is too
    // large to process (above 50MP).
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if the image_uri is missing or longer than 4096
    //   characters.
    // * Returns INVALID_ARGUMENT if the product does not exist.
    // * Returns INVALID_ARGUMENT if bounding_poly is not provided, and nothing
    //   compatible with the parent product's product_category is detected.
    // * Returns INVALID_ARGUMENT if bounding_poly contains more than 10 polygons.
    virtual ::grpc::Status CreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::google::cloud::vision::v1::ReferenceImage* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>> AsyncCreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>>(AsyncCreateReferenceImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>> PrepareAsyncCreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>>(PrepareAsyncCreateReferenceImageRaw(context, request, cq));
    }
    // Permanently deletes a reference image.
    //
    // The image metadata will be deleted right away, but search queries
    // against ProductSets containing the image may still work until all related
    // caches are refreshed.
    //
    // The actual image files are not deleted from Google Cloud Storage.
    virtual ::grpc::Status DeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteReferenceImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteReferenceImageRaw(context, request, cq));
    }
    // Lists reference images.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the parent product does not exist.
    // * Returns INVALID_ARGUMENT if the page_size is greater than 100, or less
    //   than 1.
    virtual ::grpc::Status ListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::google::cloud::vision::v1::ListReferenceImagesResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListReferenceImagesResponse>> AsyncListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListReferenceImagesResponse>>(AsyncListReferenceImagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListReferenceImagesResponse>> PrepareAsyncListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListReferenceImagesResponse>>(PrepareAsyncListReferenceImagesRaw(context, request, cq));
    }
    // Gets information associated with a ReferenceImage.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the specified image does not exist.
    virtual ::grpc::Status GetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::google::cloud::vision::v1::ReferenceImage* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>> AsyncGetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>>(AsyncGetReferenceImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>> PrepareAsyncGetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>>(PrepareAsyncGetReferenceImageRaw(context, request, cq));
    }
    // Adds a Product to the specified ProductSet. If the Product is already
    // present, no change is made.
    //
    // One Product can be added to at most 100 ProductSets.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the Product or the ProductSet doesn't exist.
    virtual ::grpc::Status AddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncAddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncAddProductToProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncAddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncAddProductToProductSetRaw(context, request, cq));
    }
    // Removes a Product from the specified ProductSet.
    virtual ::grpc::Status RemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncRemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncRemoveProductFromProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncRemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncRemoveProductFromProductSetRaw(context, request, cq));
    }
    // Lists the Products in a ProductSet, in an unspecified order. If the
    // ProductSet does not exist, the products field of the response will be
    // empty.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if page_size is greater than 100 or less than 1.
    virtual ::grpc::Status ListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::google::cloud::vision::v1::ListProductsInProductSetResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsInProductSetResponse>> AsyncListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsInProductSetResponse>>(AsyncListProductsInProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsInProductSetResponse>> PrepareAsyncListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsInProductSetResponse>>(PrepareAsyncListProductsInProductSetRaw(context, request, cq));
    }
    // Asynchronous API that imports a list of reference images to specified
    // product sets based on a list of image information.
    //
    // The [google.longrunning.Operation][google.longrunning.Operation] API can be
    // used to keep track of the progress and results of the request.
    // `Operation.metadata` contains `BatchOperationMetadata`. (progress)
    // `Operation.response` contains `ImportProductSetsResponse`. (results)
    //
    // The input source of this method is a csv file on Google Cloud Storage.
    // For the format of the csv file please see
    // [ImportProductSetsGcsSource.csv_file_uri][google.cloud.vision.v1.ImportProductSetsGcsSource.csv_file_uri].
    virtual ::grpc::Status ImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncImportProductSetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncImportProductSetsRaw(context, request, cq));
    }
    // Asynchronous API to delete all Products in a ProductSet or all Products
    // that are in no ProductSet.
    //
    // If a Product is a member of the specified ProductSet in addition to other
    // ProductSets, the Product will still be deleted.
    //
    // It is recommended to not delete the specified ProductSet until after this
    // operation has completed. It is also recommended to not add any of the
    // Products involved in the batch delete to a new ProductSet while this
    // operation is running because those Products may still end up deleted.
    //
    // It's not possible to undo the PurgeProducts operation. Therefore, it is
    // recommended to keep the csv files used in ImportProductSets (if that was
    // how you originally built the Product Set) before starting PurgeProducts, in
    // case you need to re-import the data after deletion.
    //
    // If the plan is to purge all of the Products from a ProductSet and then
    // re-use the empty ProductSet to re-import new Products into the empty
    // ProductSet, you must wait until the PurgeProducts operation has finished
    // for that ProductSet.
    //
    // The [google.longrunning.Operation][google.longrunning.Operation] API can be
    // used to keep track of the progress and results of the request.
    // `Operation.metadata` contains `BatchOperationMetadata`. (progress)
    virtual ::grpc::Status PurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncPurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncPurgeProductsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncPurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncPurgeProductsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates and returns a new ProductSet resource.
      //
      // Possible errors:
      //
      // * Returns INVALID_ARGUMENT if display_name is missing, or is longer than
      //   4096 characters.
      virtual void CreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists ProductSets in an unspecified order.
      //
      // Possible errors:
      //
      // * Returns INVALID_ARGUMENT if page_size is greater than 100, or less
      //   than 1.
      virtual void ListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest* request, ::google::cloud::vision::v1::ListProductSetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest* request, ::google::cloud::vision::v1::ListProductSetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets information associated with a ProductSet.
      //
      // Possible errors:
      //
      // * Returns NOT_FOUND if the ProductSet does not exist.
      virtual void GetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Makes changes to a ProductSet resource.
      // Only display_name can be updated currently.
      //
      // Possible errors:
      //
      // * Returns NOT_FOUND if the ProductSet does not exist.
      // * Returns INVALID_ARGUMENT if display_name is present in update_mask but
      //   missing from the request or longer than 4096 characters.
      virtual void UpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Permanently deletes a ProductSet. Products and ReferenceImages in the
      // ProductSet are not deleted.
      //
      // The actual image files are not deleted from Google Cloud Storage.
      virtual void DeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates and returns a new product resource.
      //
      // Possible errors:
      //
      // * Returns INVALID_ARGUMENT if display_name is missing or longer than 4096
      //   characters.
      // * Returns INVALID_ARGUMENT if description is longer than 4096 characters.
      // * Returns INVALID_ARGUMENT if product_category is missing or invalid.
      virtual void CreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest* request, ::google::cloud::vision::v1::Product* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest* request, ::google::cloud::vision::v1::Product* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists products in an unspecified order.
      //
      // Possible errors:
      //
      // * Returns INVALID_ARGUMENT if page_size is greater than 100 or less than 1.
      virtual void ListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest* request, ::google::cloud::vision::v1::ListProductsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest* request, ::google::cloud::vision::v1::ListProductsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets information associated with a Product.
      //
      // Possible errors:
      //
      // * Returns NOT_FOUND if the Product does not exist.
      virtual void GetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest* request, ::google::cloud::vision::v1::Product* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest* request, ::google::cloud::vision::v1::Product* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Makes changes to a Product resource.
      // Only the `display_name`, `description`, and `labels` fields can be updated
      // right now.
      //
      // If labels are updated, the change will not be reflected in queries until
      // the next index time.
      //
      // Possible errors:
      //
      // * Returns NOT_FOUND if the Product does not exist.
      // * Returns INVALID_ARGUMENT if display_name is present in update_mask but is
      //   missing from the request or longer than 4096 characters.
      // * Returns INVALID_ARGUMENT if description is present in update_mask but is
      //   longer than 4096 characters.
      // * Returns INVALID_ARGUMENT if product_category is present in update_mask.
      virtual void UpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest* request, ::google::cloud::vision::v1::Product* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest* request, ::google::cloud::vision::v1::Product* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Permanently deletes a product and its reference images.
      //
      // Metadata of the product and all its images will be deleted right away, but
      // search queries against ProductSets containing the product may still work
      // until all related caches are refreshed.
      virtual void DeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates and returns a new ReferenceImage resource.
      //
      // The `bounding_poly` field is optional. If `bounding_poly` is not specified,
      // the system will try to detect regions of interest in the image that are
      // compatible with the product_category on the parent product. If it is
      // specified, detection is ALWAYS skipped. The system converts polygons into
      // non-rotated rectangles.
      //
      // Note that the pipeline will resize the image if the image resolution is too
      // large to process (above 50MP).
      //
      // Possible errors:
      //
      // * Returns INVALID_ARGUMENT if the image_uri is missing or longer than 4096
      //   characters.
      // * Returns INVALID_ARGUMENT if the product does not exist.
      // * Returns INVALID_ARGUMENT if bounding_poly is not provided, and nothing
      //   compatible with the parent product's product_category is detected.
      // * Returns INVALID_ARGUMENT if bounding_poly contains more than 10 polygons.
      virtual void CreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Permanently deletes a reference image.
      //
      // The image metadata will be deleted right away, but search queries
      // against ProductSets containing the image may still work until all related
      // caches are refreshed.
      //
      // The actual image files are not deleted from Google Cloud Storage.
      virtual void DeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists reference images.
      //
      // Possible errors:
      //
      // * Returns NOT_FOUND if the parent product does not exist.
      // * Returns INVALID_ARGUMENT if the page_size is greater than 100, or less
      //   than 1.
      virtual void ListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest* request, ::google::cloud::vision::v1::ListReferenceImagesResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest* request, ::google::cloud::vision::v1::ListReferenceImagesResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets information associated with a ReferenceImage.
      //
      // Possible errors:
      //
      // * Returns NOT_FOUND if the specified image does not exist.
      virtual void GetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Adds a Product to the specified ProductSet. If the Product is already
      // present, no change is made.
      //
      // One Product can be added to at most 100 ProductSets.
      //
      // Possible errors:
      //
      // * Returns NOT_FOUND if the Product or the ProductSet doesn't exist.
      virtual void AddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void AddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Removes a Product from the specified ProductSet.
      virtual void RemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void RemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Lists the Products in a ProductSet, in an unspecified order. If the
      // ProductSet does not exist, the products field of the response will be
      // empty.
      //
      // Possible errors:
      //
      // * Returns INVALID_ARGUMENT if page_size is greater than 100 or less than 1.
      virtual void ListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* request, ::google::cloud::vision::v1::ListProductsInProductSetResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* request, ::google::cloud::vision::v1::ListProductsInProductSetResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Asynchronous API that imports a list of reference images to specified
      // product sets based on a list of image information.
      //
      // The [google.longrunning.Operation][google.longrunning.Operation] API can be
      // used to keep track of the progress and results of the request.
      // `Operation.metadata` contains `BatchOperationMetadata`. (progress)
      // `Operation.response` contains `ImportProductSetsResponse`. (results)
      //
      // The input source of this method is a csv file on Google Cloud Storage.
      // For the format of the csv file please see
      // [ImportProductSetsGcsSource.csv_file_uri][google.cloud.vision.v1.ImportProductSetsGcsSource.csv_file_uri].
      virtual void ImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Asynchronous API to delete all Products in a ProductSet or all Products
      // that are in no ProductSet.
      //
      // If a Product is a member of the specified ProductSet in addition to other
      // ProductSets, the Product will still be deleted.
      //
      // It is recommended to not delete the specified ProductSet until after this
      // operation has completed. It is also recommended to not add any of the
      // Products involved in the batch delete to a new ProductSet while this
      // operation is running because those Products may still end up deleted.
      //
      // It's not possible to undo the PurgeProducts operation. Therefore, it is
      // recommended to keep the csv files used in ImportProductSets (if that was
      // how you originally built the Product Set) before starting PurgeProducts, in
      // case you need to re-import the data after deletion.
      //
      // If the plan is to purge all of the Products from a ProductSet and then
      // re-use the empty ProductSet to re-import new Products into the empty
      // ProductSet, you must wait until the PurgeProducts operation has finished
      // for that ProductSet.
      //
      // The [google.longrunning.Operation][google.longrunning.Operation] API can be
      // used to keep track of the progress and results of the request.
      // `Operation.metadata` contains `BatchOperationMetadata`. (progress)
      virtual void PurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void PurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>* AsyncCreateProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>* PrepareAsyncCreateProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductSetsResponse>* AsyncListProductSetsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductSetsResponse>* PrepareAsyncListProductSetsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>* AsyncGetProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>* PrepareAsyncGetProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>* AsyncUpdateProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ProductSet>* PrepareAsyncUpdateProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>* AsyncCreateProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>* PrepareAsyncCreateProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsResponse>* AsyncListProductsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsResponse>* PrepareAsyncListProductsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>* AsyncGetProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>* PrepareAsyncGetProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>* AsyncUpdateProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::Product>* PrepareAsyncUpdateProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>* AsyncCreateReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>* PrepareAsyncCreateReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListReferenceImagesResponse>* AsyncListReferenceImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListReferenceImagesResponse>* PrepareAsyncListReferenceImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>* AsyncGetReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ReferenceImage>* PrepareAsyncGetReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncAddProductToProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncAddProductToProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncRemoveProductFromProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncRemoveProductFromProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsInProductSetResponse>* AsyncListProductsInProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::vision::v1::ListProductsInProductSetResponse>* PrepareAsyncListProductsInProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncImportProductSetsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncImportProductSetsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncPurgeProductsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncPurgeProductsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::google::cloud::vision::v1::ProductSet* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>> AsyncCreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>>(AsyncCreateProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>> PrepareAsyncCreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>>(PrepareAsyncCreateProductSetRaw(context, request, cq));
    }
    ::grpc::Status ListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::google::cloud::vision::v1::ListProductSetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductSetsResponse>> AsyncListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductSetsResponse>>(AsyncListProductSetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductSetsResponse>> PrepareAsyncListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductSetsResponse>>(PrepareAsyncListProductSetsRaw(context, request, cq));
    }
    ::grpc::Status GetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::google::cloud::vision::v1::ProductSet* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>> AsyncGetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>>(AsyncGetProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>> PrepareAsyncGetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>>(PrepareAsyncGetProductSetRaw(context, request, cq));
    }
    ::grpc::Status UpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::google::cloud::vision::v1::ProductSet* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>> AsyncUpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>>(AsyncUpdateProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>> PrepareAsyncUpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>>(PrepareAsyncUpdateProductSetRaw(context, request, cq));
    }
    ::grpc::Status DeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteProductSetRaw(context, request, cq));
    }
    ::grpc::Status CreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::google::cloud::vision::v1::Product* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>> AsyncCreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>>(AsyncCreateProductRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>> PrepareAsyncCreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>>(PrepareAsyncCreateProductRaw(context, request, cq));
    }
    ::grpc::Status ListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::google::cloud::vision::v1::ListProductsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsResponse>> AsyncListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsResponse>>(AsyncListProductsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsResponse>> PrepareAsyncListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsResponse>>(PrepareAsyncListProductsRaw(context, request, cq));
    }
    ::grpc::Status GetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::google::cloud::vision::v1::Product* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>> AsyncGetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>>(AsyncGetProductRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>> PrepareAsyncGetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>>(PrepareAsyncGetProductRaw(context, request, cq));
    }
    ::grpc::Status UpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::google::cloud::vision::v1::Product* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>> AsyncUpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>>(AsyncUpdateProductRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>> PrepareAsyncUpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>>(PrepareAsyncUpdateProductRaw(context, request, cq));
    }
    ::grpc::Status DeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteProductRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteProductRaw(context, request, cq));
    }
    ::grpc::Status CreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::google::cloud::vision::v1::ReferenceImage* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>> AsyncCreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>>(AsyncCreateReferenceImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>> PrepareAsyncCreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>>(PrepareAsyncCreateReferenceImageRaw(context, request, cq));
    }
    ::grpc::Status DeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteReferenceImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteReferenceImageRaw(context, request, cq));
    }
    ::grpc::Status ListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::google::cloud::vision::v1::ListReferenceImagesResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListReferenceImagesResponse>> AsyncListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListReferenceImagesResponse>>(AsyncListReferenceImagesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListReferenceImagesResponse>> PrepareAsyncListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListReferenceImagesResponse>>(PrepareAsyncListReferenceImagesRaw(context, request, cq));
    }
    ::grpc::Status GetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::google::cloud::vision::v1::ReferenceImage* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>> AsyncGetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>>(AsyncGetReferenceImageRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>> PrepareAsyncGetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>>(PrepareAsyncGetReferenceImageRaw(context, request, cq));
    }
    ::grpc::Status AddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncAddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncAddProductToProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncAddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncAddProductToProductSetRaw(context, request, cq));
    }
    ::grpc::Status RemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncRemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncRemoveProductFromProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncRemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncRemoveProductFromProductSetRaw(context, request, cq));
    }
    ::grpc::Status ListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::google::cloud::vision::v1::ListProductsInProductSetResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsInProductSetResponse>> AsyncListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsInProductSetResponse>>(AsyncListProductsInProductSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsInProductSetResponse>> PrepareAsyncListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsInProductSetResponse>>(PrepareAsyncListProductsInProductSetRaw(context, request, cq));
    }
    ::grpc::Status ImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncImportProductSetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncImportProductSetsRaw(context, request, cq));
    }
    ::grpc::Status PurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncPurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncPurgeProductsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncPurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncPurgeProductsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, std::function<void(::grpc::Status)>) override;
      void CreateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest* request, ::google::cloud::vision::v1::ListProductSetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest* request, ::google::cloud::vision::v1::ListProductSetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, std::function<void(::grpc::Status)>) override;
      void GetProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, std::function<void(::grpc::Status)>) override;
      void UpdateProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest* request, ::google::cloud::vision::v1::Product* response, std::function<void(::grpc::Status)>) override;
      void CreateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest* request, ::google::cloud::vision::v1::Product* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest* request, ::google::cloud::vision::v1::ListProductsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest* request, ::google::cloud::vision::v1::ListProductsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest* request, ::google::cloud::vision::v1::Product* response, std::function<void(::grpc::Status)>) override;
      void GetProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest* request, ::google::cloud::vision::v1::Product* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest* request, ::google::cloud::vision::v1::Product* response, std::function<void(::grpc::Status)>) override;
      void UpdateProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest* request, ::google::cloud::vision::v1::Product* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteProduct(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response, std::function<void(::grpc::Status)>) override;
      void CreateReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest* request, ::google::cloud::vision::v1::ListReferenceImagesResponse* response, std::function<void(::grpc::Status)>) override;
      void ListReferenceImages(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest* request, ::google::cloud::vision::v1::ListReferenceImagesResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response, std::function<void(::grpc::Status)>) override;
      void GetReferenceImage(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response, ::grpc::ClientUnaryReactor* reactor) override;
      void AddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void AddProductToProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void RemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void RemoveProductFromProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* request, ::google::cloud::vision::v1::ListProductsInProductSetResponse* response, std::function<void(::grpc::Status)>) override;
      void ListProductsInProductSet(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* request, ::google::cloud::vision::v1::ListProductsInProductSetResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void ImportProductSets(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void PurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void PurgeProducts(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>* AsyncCreateProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>* PrepareAsyncCreateProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductSetsResponse>* AsyncListProductSetsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductSetsResponse>* PrepareAsyncListProductSetsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>* AsyncGetProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>* PrepareAsyncGetProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>* AsyncUpdateProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ProductSet>* PrepareAsyncUpdateProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>* AsyncCreateProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>* PrepareAsyncCreateProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateProductRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsResponse>* AsyncListProductsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsResponse>* PrepareAsyncListProductsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>* AsyncGetProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>* PrepareAsyncGetProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetProductRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>* AsyncUpdateProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::Product>* PrepareAsyncUpdateProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::UpdateProductRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteProductRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteProductRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>* AsyncCreateReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>* PrepareAsyncCreateReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListReferenceImagesResponse>* AsyncListReferenceImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListReferenceImagesResponse>* PrepareAsyncListReferenceImagesRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>* AsyncGetReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ReferenceImage>* PrepareAsyncGetReferenceImageRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncAddProductToProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncAddProductToProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncRemoveProductFromProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncRemoveProductFromProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsInProductSetResponse>* AsyncListProductsInProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::vision::v1::ListProductsInProductSetResponse>* PrepareAsyncListProductsInProductSetRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncImportProductSetsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncImportProductSetsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncPurgeProductsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncPurgeProductsRaw(::grpc::ClientContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateProductSet_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProductSets_;
    const ::grpc::internal::RpcMethod rpcmethod_GetProductSet_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateProductSet_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteProductSet_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateProduct_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProducts_;
    const ::grpc::internal::RpcMethod rpcmethod_GetProduct_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateProduct_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteProduct_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateReferenceImage_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteReferenceImage_;
    const ::grpc::internal::RpcMethod rpcmethod_ListReferenceImages_;
    const ::grpc::internal::RpcMethod rpcmethod_GetReferenceImage_;
    const ::grpc::internal::RpcMethod rpcmethod_AddProductToProductSet_;
    const ::grpc::internal::RpcMethod rpcmethod_RemoveProductFromProductSet_;
    const ::grpc::internal::RpcMethod rpcmethod_ListProductsInProductSet_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportProductSets_;
    const ::grpc::internal::RpcMethod rpcmethod_PurgeProducts_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates and returns a new ProductSet resource.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if display_name is missing, or is longer than
    //   4096 characters.
    virtual ::grpc::Status CreateProductSet(::grpc::ServerContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response);
    // Lists ProductSets in an unspecified order.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if page_size is greater than 100, or less
    //   than 1.
    virtual ::grpc::Status ListProductSets(::grpc::ServerContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest* request, ::google::cloud::vision::v1::ListProductSetsResponse* response);
    // Gets information associated with a ProductSet.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the ProductSet does not exist.
    virtual ::grpc::Status GetProductSet(::grpc::ServerContext* context, const ::google::cloud::vision::v1::GetProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response);
    // Makes changes to a ProductSet resource.
    // Only display_name can be updated currently.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the ProductSet does not exist.
    // * Returns INVALID_ARGUMENT if display_name is present in update_mask but
    //   missing from the request or longer than 4096 characters.
    virtual ::grpc::Status UpdateProductSet(::grpc::ServerContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response);
    // Permanently deletes a ProductSet. Products and ReferenceImages in the
    // ProductSet are not deleted.
    //
    // The actual image files are not deleted from Google Cloud Storage.
    virtual ::grpc::Status DeleteProductSet(::grpc::ServerContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest* request, ::google::protobuf::Empty* response);
    // Creates and returns a new product resource.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if display_name is missing or longer than 4096
    //   characters.
    // * Returns INVALID_ARGUMENT if description is longer than 4096 characters.
    // * Returns INVALID_ARGUMENT if product_category is missing or invalid.
    virtual ::grpc::Status CreateProduct(::grpc::ServerContext* context, const ::google::cloud::vision::v1::CreateProductRequest* request, ::google::cloud::vision::v1::Product* response);
    // Lists products in an unspecified order.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if page_size is greater than 100 or less than 1.
    virtual ::grpc::Status ListProducts(::grpc::ServerContext* context, const ::google::cloud::vision::v1::ListProductsRequest* request, ::google::cloud::vision::v1::ListProductsResponse* response);
    // Gets information associated with a Product.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the Product does not exist.
    virtual ::grpc::Status GetProduct(::grpc::ServerContext* context, const ::google::cloud::vision::v1::GetProductRequest* request, ::google::cloud::vision::v1::Product* response);
    // Makes changes to a Product resource.
    // Only the `display_name`, `description`, and `labels` fields can be updated
    // right now.
    //
    // If labels are updated, the change will not be reflected in queries until
    // the next index time.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the Product does not exist.
    // * Returns INVALID_ARGUMENT if display_name is present in update_mask but is
    //   missing from the request or longer than 4096 characters.
    // * Returns INVALID_ARGUMENT if description is present in update_mask but is
    //   longer than 4096 characters.
    // * Returns INVALID_ARGUMENT if product_category is present in update_mask.
    virtual ::grpc::Status UpdateProduct(::grpc::ServerContext* context, const ::google::cloud::vision::v1::UpdateProductRequest* request, ::google::cloud::vision::v1::Product* response);
    // Permanently deletes a product and its reference images.
    //
    // Metadata of the product and all its images will be deleted right away, but
    // search queries against ProductSets containing the product may still work
    // until all related caches are refreshed.
    virtual ::grpc::Status DeleteProduct(::grpc::ServerContext* context, const ::google::cloud::vision::v1::DeleteProductRequest* request, ::google::protobuf::Empty* response);
    // Creates and returns a new ReferenceImage resource.
    //
    // The `bounding_poly` field is optional. If `bounding_poly` is not specified,
    // the system will try to detect regions of interest in the image that are
    // compatible with the product_category on the parent product. If it is
    // specified, detection is ALWAYS skipped. The system converts polygons into
    // non-rotated rectangles.
    //
    // Note that the pipeline will resize the image if the image resolution is too
    // large to process (above 50MP).
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if the image_uri is missing or longer than 4096
    //   characters.
    // * Returns INVALID_ARGUMENT if the product does not exist.
    // * Returns INVALID_ARGUMENT if bounding_poly is not provided, and nothing
    //   compatible with the parent product's product_category is detected.
    // * Returns INVALID_ARGUMENT if bounding_poly contains more than 10 polygons.
    virtual ::grpc::Status CreateReferenceImage(::grpc::ServerContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response);
    // Permanently deletes a reference image.
    //
    // The image metadata will be deleted right away, but search queries
    // against ProductSets containing the image may still work until all related
    // caches are refreshed.
    //
    // The actual image files are not deleted from Google Cloud Storage.
    virtual ::grpc::Status DeleteReferenceImage(::grpc::ServerContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* request, ::google::protobuf::Empty* response);
    // Lists reference images.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the parent product does not exist.
    // * Returns INVALID_ARGUMENT if the page_size is greater than 100, or less
    //   than 1.
    virtual ::grpc::Status ListReferenceImages(::grpc::ServerContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest* request, ::google::cloud::vision::v1::ListReferenceImagesResponse* response);
    // Gets information associated with a ReferenceImage.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the specified image does not exist.
    virtual ::grpc::Status GetReferenceImage(::grpc::ServerContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response);
    // Adds a Product to the specified ProductSet. If the Product is already
    // present, no change is made.
    //
    // One Product can be added to at most 100 ProductSets.
    //
    // Possible errors:
    //
    // * Returns NOT_FOUND if the Product or the ProductSet doesn't exist.
    virtual ::grpc::Status AddProductToProductSet(::grpc::ServerContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest* request, ::google::protobuf::Empty* response);
    // Removes a Product from the specified ProductSet.
    virtual ::grpc::Status RemoveProductFromProductSet(::grpc::ServerContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* request, ::google::protobuf::Empty* response);
    // Lists the Products in a ProductSet, in an unspecified order. If the
    // ProductSet does not exist, the products field of the response will be
    // empty.
    //
    // Possible errors:
    //
    // * Returns INVALID_ARGUMENT if page_size is greater than 100 or less than 1.
    virtual ::grpc::Status ListProductsInProductSet(::grpc::ServerContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* request, ::google::cloud::vision::v1::ListProductsInProductSetResponse* response);
    // Asynchronous API that imports a list of reference images to specified
    // product sets based on a list of image information.
    //
    // The [google.longrunning.Operation][google.longrunning.Operation] API can be
    // used to keep track of the progress and results of the request.
    // `Operation.metadata` contains `BatchOperationMetadata`. (progress)
    // `Operation.response` contains `ImportProductSetsResponse`. (results)
    //
    // The input source of this method is a csv file on Google Cloud Storage.
    // For the format of the csv file please see
    // [ImportProductSetsGcsSource.csv_file_uri][google.cloud.vision.v1.ImportProductSetsGcsSource.csv_file_uri].
    virtual ::grpc::Status ImportProductSets(::grpc::ServerContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest* request, ::google::longrunning::Operation* response);
    // Asynchronous API to delete all Products in a ProductSet or all Products
    // that are in no ProductSet.
    //
    // If a Product is a member of the specified ProductSet in addition to other
    // ProductSets, the Product will still be deleted.
    //
    // It is recommended to not delete the specified ProductSet until after this
    // operation has completed. It is also recommended to not add any of the
    // Products involved in the batch delete to a new ProductSet while this
    // operation is running because those Products may still end up deleted.
    //
    // It's not possible to undo the PurgeProducts operation. Therefore, it is
    // recommended to keep the csv files used in ImportProductSets (if that was
    // how you originally built the Product Set) before starting PurgeProducts, in
    // case you need to re-import the data after deletion.
    //
    // If the plan is to purge all of the Products from a ProductSet and then
    // re-use the empty ProductSet to re-import new Products into the empty
    // ProductSet, you must wait until the PurgeProducts operation has finished
    // for that ProductSet.
    //
    // The [google.longrunning.Operation][google.longrunning.Operation] API can be
    // used to keep track of the progress and results of the request.
    // `Operation.metadata` contains `BatchOperationMetadata`. (progress)
    virtual ::grpc::Status PurgeProducts(::grpc::ServerContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateProductSet() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProductSet(::grpc::ServerContext* context, ::google::cloud::vision::v1::CreateProductSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::ProductSet>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProductSets() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductSetsRequest* /*request*/, ::google::cloud::vision::v1::ListProductSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProductSets(::grpc::ServerContext* context, ::google::cloud::vision::v1::ListProductSetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::ListProductSetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetProductSet() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProductSet(::grpc::ServerContext* context, ::google::cloud::vision::v1::GetProductSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::ProductSet>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateProductSet() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_UpdateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProductSet(::grpc::ServerContext* context, ::google::cloud::vision::v1::UpdateProductSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::ProductSet>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteProductSet() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_DeleteProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProductSet(::grpc::ServerContext* context, ::google::cloud::vision::v1::DeleteProductSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateProduct() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_CreateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProduct(::grpc::ServerContext* context, ::google::cloud::vision::v1::CreateProductRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::Product>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProducts() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsRequest* /*request*/, ::google::cloud::vision::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProducts(::grpc::ServerContext* context, ::google::cloud::vision::v1::ListProductsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::ListProductsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetProduct() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_GetProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProduct(::grpc::ServerContext* context, ::google::cloud::vision::v1::GetProductRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::Product>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateProduct() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_UpdateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProduct(::grpc::ServerContext* context, ::google::cloud::vision::v1::UpdateProductRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::Product>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteProduct() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_DeleteProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProduct(::grpc::ServerContext* context, ::google::cloud::vision::v1::DeleteProductRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateReferenceImage() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_CreateReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateReferenceImage(::grpc::ServerContext* context, ::google::cloud::vision::v1::CreateReferenceImageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::ReferenceImage>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteReferenceImage() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_DeleteReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteReferenceImage(::grpc::ServerContext* context, ::google::cloud::vision::v1::DeleteReferenceImageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListReferenceImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListReferenceImages() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_ListReferenceImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReferenceImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListReferenceImagesRequest* /*request*/, ::google::cloud::vision::v1::ListReferenceImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReferenceImages(::grpc::ServerContext* context, ::google::cloud::vision::v1::ListReferenceImagesRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::ListReferenceImagesResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetReferenceImage() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_GetReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetReferenceImage(::grpc::ServerContext* context, ::google::cloud::vision::v1::GetReferenceImageRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::ReferenceImage>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_AddProductToProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_AddProductToProductSet() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_AddProductToProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddProductToProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AddProductToProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddProductToProductSet(::grpc::ServerContext* context, ::google::cloud::vision::v1::AddProductToProductSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_RemoveProductFromProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_RemoveProductFromProductSet() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_RemoveProductFromProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveProductFromProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRemoveProductFromProductSet(::grpc::ServerContext* context, ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListProductsInProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListProductsInProductSet() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_ListProductsInProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductsInProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* /*request*/, ::google::cloud::vision::v1::ListProductsInProductSetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProductsInProductSet(::grpc::ServerContext* context, ::google::cloud::vision::v1::ListProductsInProductSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::vision::v1::ListProductsInProductSetResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportProductSets() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_ImportProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ImportProductSetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportProductSets(::grpc::ServerContext* context, ::google::cloud::vision::v1::ImportProductSetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_PurgeProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_PurgeProducts() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_PurgeProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::PurgeProductsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPurgeProducts(::grpc::ServerContext* context, ::google::cloud::vision::v1::PurgeProductsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateProductSet<WithAsyncMethod_ListProductSets<WithAsyncMethod_GetProductSet<WithAsyncMethod_UpdateProductSet<WithAsyncMethod_DeleteProductSet<WithAsyncMethod_CreateProduct<WithAsyncMethod_ListProducts<WithAsyncMethod_GetProduct<WithAsyncMethod_UpdateProduct<WithAsyncMethod_DeleteProduct<WithAsyncMethod_CreateReferenceImage<WithAsyncMethod_DeleteReferenceImage<WithAsyncMethod_ListReferenceImages<WithAsyncMethod_GetReferenceImage<WithAsyncMethod_AddProductToProductSet<WithAsyncMethod_RemoveProductFromProductSet<WithAsyncMethod_ListProductsInProductSet<WithAsyncMethod_ImportProductSets<WithAsyncMethod_PurgeProducts<Service > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateProductSet() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::CreateProductSetRequest, ::google::cloud::vision::v1::ProductSet>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::CreateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response) { return this->CreateProductSet(context, request, response); }));}
    void SetMessageAllocatorFor_CreateProductSet(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::CreateProductSetRequest, ::google::cloud::vision::v1::ProductSet>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::CreateProductSetRequest, ::google::cloud::vision::v1::ProductSet>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProductSets() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ListProductSetsRequest, ::google::cloud::vision::v1::ListProductSetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::ListProductSetsRequest* request, ::google::cloud::vision::v1::ListProductSetsResponse* response) { return this->ListProductSets(context, request, response); }));}
    void SetMessageAllocatorFor_ListProductSets(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::ListProductSetsRequest, ::google::cloud::vision::v1::ListProductSetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ListProductSetsRequest, ::google::cloud::vision::v1::ListProductSetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductSetsRequest* /*request*/, ::google::cloud::vision::v1::ListProductSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProductSets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductSetsRequest* /*request*/, ::google::cloud::vision::v1::ListProductSetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetProductSet() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::GetProductSetRequest, ::google::cloud::vision::v1::ProductSet>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::GetProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response) { return this->GetProductSet(context, request, response); }));}
    void SetMessageAllocatorFor_GetProductSet(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::GetProductSetRequest, ::google::cloud::vision::v1::ProductSet>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::GetProductSetRequest, ::google::cloud::vision::v1::ProductSet>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateProductSet() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::UpdateProductSetRequest, ::google::cloud::vision::v1::ProductSet>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::UpdateProductSetRequest* request, ::google::cloud::vision::v1::ProductSet* response) { return this->UpdateProductSet(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateProductSet(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::UpdateProductSetRequest, ::google::cloud::vision::v1::ProductSet>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::UpdateProductSetRequest, ::google::cloud::vision::v1::ProductSet>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteProductSet() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::DeleteProductSetRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::DeleteProductSetRequest* request, ::google::protobuf::Empty* response) { return this->DeleteProductSet(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteProductSet(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::DeleteProductSetRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::DeleteProductSetRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateProduct() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::CreateProductRequest, ::google::cloud::vision::v1::Product>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::CreateProductRequest* request, ::google::cloud::vision::v1::Product* response) { return this->CreateProduct(context, request, response); }));}
    void SetMessageAllocatorFor_CreateProduct(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::CreateProductRequest, ::google::cloud::vision::v1::Product>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::CreateProductRequest, ::google::cloud::vision::v1::Product>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProduct(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProducts() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ListProductsRequest, ::google::cloud::vision::v1::ListProductsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::ListProductsRequest* request, ::google::cloud::vision::v1::ListProductsResponse* response) { return this->ListProducts(context, request, response); }));}
    void SetMessageAllocatorFor_ListProducts(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::ListProductsRequest, ::google::cloud::vision::v1::ListProductsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ListProductsRequest, ::google::cloud::vision::v1::ListProductsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsRequest* /*request*/, ::google::cloud::vision::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProducts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsRequest* /*request*/, ::google::cloud::vision::v1::ListProductsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetProduct() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::GetProductRequest, ::google::cloud::vision::v1::Product>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::GetProductRequest* request, ::google::cloud::vision::v1::Product* response) { return this->GetProduct(context, request, response); }));}
    void SetMessageAllocatorFor_GetProduct(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::GetProductRequest, ::google::cloud::vision::v1::Product>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::GetProductRequest, ::google::cloud::vision::v1::Product>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProduct(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateProduct() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::UpdateProductRequest, ::google::cloud::vision::v1::Product>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::UpdateProductRequest* request, ::google::cloud::vision::v1::Product* response) { return this->UpdateProduct(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateProduct(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::UpdateProductRequest, ::google::cloud::vision::v1::Product>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::UpdateProductRequest, ::google::cloud::vision::v1::Product>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProduct(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteProduct() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::DeleteProductRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::DeleteProductRequest* request, ::google::protobuf::Empty* response) { return this->DeleteProduct(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteProduct(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::DeleteProductRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::DeleteProductRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProduct(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateReferenceImage() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::CreateReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::CreateReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response) { return this->CreateReferenceImage(context, request, response); }));}
    void SetMessageAllocatorFor_CreateReferenceImage(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::CreateReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::CreateReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateReferenceImage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::CreateReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteReferenceImage() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::DeleteReferenceImageRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* request, ::google::protobuf::Empty* response) { return this->DeleteReferenceImage(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteReferenceImage(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::DeleteReferenceImageRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::DeleteReferenceImageRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteReferenceImage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListReferenceImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListReferenceImages() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ListReferenceImagesRequest, ::google::cloud::vision::v1::ListReferenceImagesResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::ListReferenceImagesRequest* request, ::google::cloud::vision::v1::ListReferenceImagesResponse* response) { return this->ListReferenceImages(context, request, response); }));}
    void SetMessageAllocatorFor_ListReferenceImages(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::ListReferenceImagesRequest, ::google::cloud::vision::v1::ListReferenceImagesResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ListReferenceImagesRequest, ::google::cloud::vision::v1::ListReferenceImagesResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListReferenceImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReferenceImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListReferenceImagesRequest* /*request*/, ::google::cloud::vision::v1::ListReferenceImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReferenceImages(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::ListReferenceImagesRequest* /*request*/, ::google::cloud::vision::v1::ListReferenceImagesResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetReferenceImage() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::GetReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::GetReferenceImageRequest* request, ::google::cloud::vision::v1::ReferenceImage* response) { return this->GetReferenceImage(context, request, response); }));}
    void SetMessageAllocatorFor_GetReferenceImage(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::GetReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::GetReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetReferenceImage(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::GetReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_AddProductToProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_AddProductToProductSet() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::AddProductToProductSetRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::AddProductToProductSetRequest* request, ::google::protobuf::Empty* response) { return this->AddProductToProductSet(context, request, response); }));}
    void SetMessageAllocatorFor_AddProductToProductSet(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::AddProductToProductSetRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::AddProductToProductSetRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_AddProductToProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddProductToProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AddProductToProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddProductToProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::AddProductToProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_RemoveProductFromProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_RemoveProductFromProductSet() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::RemoveProductFromProductSetRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* request, ::google::protobuf::Empty* response) { return this->RemoveProductFromProductSet(context, request, response); }));}
    void SetMessageAllocatorFor_RemoveProductFromProductSet(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::RemoveProductFromProductSetRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::RemoveProductFromProductSetRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_RemoveProductFromProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveProductFromProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RemoveProductFromProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListProductsInProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListProductsInProductSet() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ListProductsInProductSetRequest, ::google::cloud::vision::v1::ListProductsInProductSetResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* request, ::google::cloud::vision::v1::ListProductsInProductSetResponse* response) { return this->ListProductsInProductSet(context, request, response); }));}
    void SetMessageAllocatorFor_ListProductsInProductSet(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::ListProductsInProductSetRequest, ::google::cloud::vision::v1::ListProductsInProductSetResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ListProductsInProductSetRequest, ::google::cloud::vision::v1::ListProductsInProductSetResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListProductsInProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductsInProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* /*request*/, ::google::cloud::vision::v1::ListProductsInProductSetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProductsInProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* /*request*/, ::google::cloud::vision::v1::ListProductsInProductSetResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportProductSets() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ImportProductSetsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::ImportProductSetsRequest* request, ::google::longrunning::Operation* response) { return this->ImportProductSets(context, request, response); }));}
    void SetMessageAllocatorFor_ImportProductSets(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::ImportProductSetsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::ImportProductSetsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ImportProductSetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportProductSets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::ImportProductSetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_PurgeProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_PurgeProducts() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::PurgeProductsRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::vision::v1::PurgeProductsRequest* request, ::google::longrunning::Operation* response) { return this->PurgeProducts(context, request, response); }));}
    void SetMessageAllocatorFor_PurgeProducts(
        ::grpc::MessageAllocator< ::google::cloud::vision::v1::PurgeProductsRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::vision::v1::PurgeProductsRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_PurgeProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::PurgeProductsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PurgeProducts(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::vision::v1::PurgeProductsRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateProductSet<WithCallbackMethod_ListProductSets<WithCallbackMethod_GetProductSet<WithCallbackMethod_UpdateProductSet<WithCallbackMethod_DeleteProductSet<WithCallbackMethod_CreateProduct<WithCallbackMethod_ListProducts<WithCallbackMethod_GetProduct<WithCallbackMethod_UpdateProduct<WithCallbackMethod_DeleteProduct<WithCallbackMethod_CreateReferenceImage<WithCallbackMethod_DeleteReferenceImage<WithCallbackMethod_ListReferenceImages<WithCallbackMethod_GetReferenceImage<WithCallbackMethod_AddProductToProductSet<WithCallbackMethod_RemoveProductFromProductSet<WithCallbackMethod_ListProductsInProductSet<WithCallbackMethod_ImportProductSets<WithCallbackMethod_PurgeProducts<Service > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateProductSet() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProductSets() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductSetsRequest* /*request*/, ::google::cloud::vision::v1::ListProductSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetProductSet() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateProductSet() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_UpdateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteProductSet() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_DeleteProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateProduct() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_CreateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProducts() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsRequest* /*request*/, ::google::cloud::vision::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetProduct() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_GetProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateProduct() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_UpdateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteProduct() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_DeleteProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateReferenceImage() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_CreateReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteReferenceImage() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_DeleteReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListReferenceImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListReferenceImages() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_ListReferenceImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReferenceImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListReferenceImagesRequest* /*request*/, ::google::cloud::vision::v1::ListReferenceImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetReferenceImage() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_GetReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_AddProductToProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_AddProductToProductSet() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_AddProductToProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddProductToProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AddProductToProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_RemoveProductFromProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_RemoveProductFromProductSet() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_RemoveProductFromProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveProductFromProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListProductsInProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListProductsInProductSet() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_ListProductsInProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductsInProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* /*request*/, ::google::cloud::vision::v1::ListProductsInProductSetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportProductSets() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_ImportProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ImportProductSetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_PurgeProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_PurgeProducts() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_PurgeProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::PurgeProductsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateProductSet() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProductSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProductSets() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductSetsRequest* /*request*/, ::google::cloud::vision::v1::ListProductSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProductSets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetProductSet() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProductSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateProductSet() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_UpdateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProductSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteProductSet() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_DeleteProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProductSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateProduct() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_CreateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateProduct(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProducts() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsRequest* /*request*/, ::google::cloud::vision::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProducts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetProduct() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_GetProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetProduct(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateProduct() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_UpdateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateProduct(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteProduct() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_DeleteProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteProduct(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateReferenceImage() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_CreateReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateReferenceImage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteReferenceImage() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_DeleteReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteReferenceImage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListReferenceImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListReferenceImages() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_ListReferenceImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReferenceImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListReferenceImagesRequest* /*request*/, ::google::cloud::vision::v1::ListReferenceImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListReferenceImages(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetReferenceImage() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_GetReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetReferenceImage(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_AddProductToProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_AddProductToProductSet() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_AddProductToProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddProductToProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AddProductToProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestAddProductToProductSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_RemoveProductFromProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_RemoveProductFromProductSet() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_RemoveProductFromProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveProductFromProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestRemoveProductFromProductSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListProductsInProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListProductsInProductSet() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_ListProductsInProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductsInProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* /*request*/, ::google::cloud::vision::v1::ListProductsInProductSetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListProductsInProductSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportProductSets() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_ImportProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ImportProductSetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportProductSets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_PurgeProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_PurgeProducts() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_PurgeProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::PurgeProductsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestPurgeProducts(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateProductSet() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateProductSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProductSets() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProductSets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductSetsRequest* /*request*/, ::google::cloud::vision::v1::ListProductSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProductSets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetProductSet() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetProductSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateProductSet() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateProductSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteProductSet() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteProductSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateProduct() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateProduct(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateProduct(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProducts() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProducts(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsRequest* /*request*/, ::google::cloud::vision::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProducts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetProduct() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetProduct(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetProduct(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateProduct() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateProduct(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateProduct(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteProduct() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteProduct(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteProduct(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateReferenceImage() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateReferenceImage(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateReferenceImage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteReferenceImage() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteReferenceImage(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteReferenceImage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListReferenceImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListReferenceImages() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListReferenceImages(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListReferenceImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListReferenceImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListReferenceImagesRequest* /*request*/, ::google::cloud::vision::v1::ListReferenceImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListReferenceImages(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetReferenceImage() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetReferenceImage(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetReferenceImage(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_AddProductToProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_AddProductToProductSet() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->AddProductToProductSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_AddProductToProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status AddProductToProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AddProductToProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* AddProductToProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_RemoveProductFromProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_RemoveProductFromProductSet() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->RemoveProductFromProductSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_RemoveProductFromProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status RemoveProductFromProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* RemoveProductFromProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListProductsInProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListProductsInProductSet() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListProductsInProductSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListProductsInProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListProductsInProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* /*request*/, ::google::cloud::vision::v1::ListProductsInProductSetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListProductsInProductSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportProductSets() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportProductSets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ImportProductSetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportProductSets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_PurgeProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_PurgeProducts() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->PurgeProducts(context, request, response); }));
    }
    ~WithRawCallbackMethod_PurgeProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status PurgeProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::PurgeProductsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* PurgeProducts(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateProductSet() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::CreateProductSetRequest, ::google::cloud::vision::v1::ProductSet>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::CreateProductSetRequest, ::google::cloud::vision::v1::ProductSet>* streamer) {
                       return this->StreamedCreateProductSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateProductSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::CreateProductSetRequest,::google::cloud::vision::v1::ProductSet>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProductSets() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::ListProductSetsRequest, ::google::cloud::vision::v1::ListProductSetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::ListProductSetsRequest, ::google::cloud::vision::v1::ListProductSetsResponse>* streamer) {
                       return this->StreamedListProductSets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductSetsRequest* /*request*/, ::google::cloud::vision::v1::ListProductSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProductSets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::ListProductSetsRequest,::google::cloud::vision::v1::ListProductSetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetProductSet() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::GetProductSetRequest, ::google::cloud::vision::v1::ProductSet>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::GetProductSetRequest, ::google::cloud::vision::v1::ProductSet>* streamer) {
                       return this->StreamedGetProductSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetProductSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::GetProductSetRequest,::google::cloud::vision::v1::ProductSet>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateProductSet() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::UpdateProductSetRequest, ::google::cloud::vision::v1::ProductSet>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::UpdateProductSetRequest, ::google::cloud::vision::v1::ProductSet>* streamer) {
                       return this->StreamedUpdateProductSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductSetRequest* /*request*/, ::google::cloud::vision::v1::ProductSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateProductSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::UpdateProductSetRequest,::google::cloud::vision::v1::ProductSet>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteProductSet() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::DeleteProductSetRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::DeleteProductSetRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteProductSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteProductSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::DeleteProductSetRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateProduct() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::CreateProductRequest, ::google::cloud::vision::v1::Product>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::CreateProductRequest, ::google::cloud::vision::v1::Product>* streamer) {
                       return this->StreamedCreateProduct(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateProduct(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::CreateProductRequest,::google::cloud::vision::v1::Product>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProducts() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::ListProductsRequest, ::google::cloud::vision::v1::ListProductsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::ListProductsRequest, ::google::cloud::vision::v1::ListProductsResponse>* streamer) {
                       return this->StreamedListProducts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsRequest* /*request*/, ::google::cloud::vision::v1::ListProductsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProducts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::ListProductsRequest,::google::cloud::vision::v1::ListProductsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetProduct() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::GetProductRequest, ::google::cloud::vision::v1::Product>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::GetProductRequest, ::google::cloud::vision::v1::Product>* streamer) {
                       return this->StreamedGetProduct(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetProduct(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::GetProductRequest,::google::cloud::vision::v1::Product>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateProduct() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::UpdateProductRequest, ::google::cloud::vision::v1::Product>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::UpdateProductRequest, ::google::cloud::vision::v1::Product>* streamer) {
                       return this->StreamedUpdateProduct(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::UpdateProductRequest* /*request*/, ::google::cloud::vision::v1::Product* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateProduct(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::UpdateProductRequest,::google::cloud::vision::v1::Product>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteProduct : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteProduct() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::DeleteProductRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::DeleteProductRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteProduct(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteProduct() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteProduct(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteProductRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteProduct(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::DeleteProductRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateReferenceImage() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::CreateReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::CreateReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>* streamer) {
                       return this->StreamedCreateReferenceImage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::CreateReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateReferenceImage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::CreateReferenceImageRequest,::google::cloud::vision::v1::ReferenceImage>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteReferenceImage() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::DeleteReferenceImageRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::DeleteReferenceImageRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteReferenceImage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::DeleteReferenceImageRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteReferenceImage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::DeleteReferenceImageRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListReferenceImages : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListReferenceImages() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::ListReferenceImagesRequest, ::google::cloud::vision::v1::ListReferenceImagesResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::ListReferenceImagesRequest, ::google::cloud::vision::v1::ListReferenceImagesResponse>* streamer) {
                       return this->StreamedListReferenceImages(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListReferenceImages() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListReferenceImages(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListReferenceImagesRequest* /*request*/, ::google::cloud::vision::v1::ListReferenceImagesResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListReferenceImages(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::ListReferenceImagesRequest,::google::cloud::vision::v1::ListReferenceImagesResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetReferenceImage : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetReferenceImage() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::GetReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::GetReferenceImageRequest, ::google::cloud::vision::v1::ReferenceImage>* streamer) {
                       return this->StreamedGetReferenceImage(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetReferenceImage() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetReferenceImage(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::GetReferenceImageRequest* /*request*/, ::google::cloud::vision::v1::ReferenceImage* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetReferenceImage(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::GetReferenceImageRequest,::google::cloud::vision::v1::ReferenceImage>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_AddProductToProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_AddProductToProductSet() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::AddProductToProductSetRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::AddProductToProductSetRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedAddProductToProductSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_AddProductToProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status AddProductToProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::AddProductToProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedAddProductToProductSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::AddProductToProductSetRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_RemoveProductFromProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_RemoveProductFromProductSet() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::RemoveProductFromProductSetRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::RemoveProductFromProductSetRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedRemoveProductFromProductSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_RemoveProductFromProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status RemoveProductFromProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::RemoveProductFromProductSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedRemoveProductFromProductSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::RemoveProductFromProductSetRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListProductsInProductSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListProductsInProductSet() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::ListProductsInProductSetRequest, ::google::cloud::vision::v1::ListProductsInProductSetResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::ListProductsInProductSetRequest, ::google::cloud::vision::v1::ListProductsInProductSetResponse>* streamer) {
                       return this->StreamedListProductsInProductSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListProductsInProductSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListProductsInProductSet(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ListProductsInProductSetRequest* /*request*/, ::google::cloud::vision::v1::ListProductsInProductSetResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListProductsInProductSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::ListProductsInProductSetRequest,::google::cloud::vision::v1::ListProductsInProductSetResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportProductSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportProductSets() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::ImportProductSetsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::ImportProductSetsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedImportProductSets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportProductSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportProductSets(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::ImportProductSetsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportProductSets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::ImportProductSetsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_PurgeProducts : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_PurgeProducts() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::vision::v1::PurgeProductsRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::vision::v1::PurgeProductsRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedPurgeProducts(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_PurgeProducts() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status PurgeProducts(::grpc::ServerContext* /*context*/, const ::google::cloud::vision::v1::PurgeProductsRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedPurgeProducts(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::vision::v1::PurgeProductsRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateProductSet<WithStreamedUnaryMethod_ListProductSets<WithStreamedUnaryMethod_GetProductSet<WithStreamedUnaryMethod_UpdateProductSet<WithStreamedUnaryMethod_DeleteProductSet<WithStreamedUnaryMethod_CreateProduct<WithStreamedUnaryMethod_ListProducts<WithStreamedUnaryMethod_GetProduct<WithStreamedUnaryMethod_UpdateProduct<WithStreamedUnaryMethod_DeleteProduct<WithStreamedUnaryMethod_CreateReferenceImage<WithStreamedUnaryMethod_DeleteReferenceImage<WithStreamedUnaryMethod_ListReferenceImages<WithStreamedUnaryMethod_GetReferenceImage<WithStreamedUnaryMethod_AddProductToProductSet<WithStreamedUnaryMethod_RemoveProductFromProductSet<WithStreamedUnaryMethod_ListProductsInProductSet<WithStreamedUnaryMethod_ImportProductSets<WithStreamedUnaryMethod_PurgeProducts<Service > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateProductSet<WithStreamedUnaryMethod_ListProductSets<WithStreamedUnaryMethod_GetProductSet<WithStreamedUnaryMethod_UpdateProductSet<WithStreamedUnaryMethod_DeleteProductSet<WithStreamedUnaryMethod_CreateProduct<WithStreamedUnaryMethod_ListProducts<WithStreamedUnaryMethod_GetProduct<WithStreamedUnaryMethod_UpdateProduct<WithStreamedUnaryMethod_DeleteProduct<WithStreamedUnaryMethod_CreateReferenceImage<WithStreamedUnaryMethod_DeleteReferenceImage<WithStreamedUnaryMethod_ListReferenceImages<WithStreamedUnaryMethod_GetReferenceImage<WithStreamedUnaryMethod_AddProductToProductSet<WithStreamedUnaryMethod_RemoveProductFromProductSet<WithStreamedUnaryMethod_ListProductsInProductSet<WithStreamedUnaryMethod_ImportProductSets<WithStreamedUnaryMethod_PurgeProducts<Service > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace vision
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fvision_2fv1_2fproduct_5fsearch_5fservice_2eproto__INCLUDED
